searchData={"items":[{"type":"module","title":"Hermes.CLI","doc":"CLI entry point for the Hermes MCP standalone binary.\n\nThis module serves as the main entry point when the application is built \nas a standalone binary with Burrito. It delegates to the Mix.Interactive.CLI\nmodule for the actual CLI implementation.","ref":"Hermes.CLI.html"},{"type":"function","title":"Hermes.CLI.main/0","doc":"Main entry point for the standalone CLI application.","ref":"Hermes.CLI.html#main/0"},{"type":"module","title":"Hermes.Client","doc":"A GenServer implementation of an MCP (Model Context Protocol) client.\n\nThis module handles the client-side implementation of the MCP protocol,\nincluding initialization, request/response handling, and maintaining\nprotocol state.","ref":"Hermes.Client.html"},{"type":"module","title":"Examples - Hermes.Client","doc":"# Start a client process\n    {:ok, client} = Hermes.Client.start_link(\n      name: MyApp.MCPClient,\n      transport: Hermes.Transport.STDIO,\n      client_info: %{\"name\" => \"MyApp\", \"version\" => \"1.0.0\"},\n      capabilities: %{\"resources\" => %{}, \"tools\" => %{}}\n    )\n\n    # List available resources\n    {:ok, resources} = Hermes.Client.list_resources(client)","ref":"Hermes.Client.html#module-examples"},{"type":"module","title":"Notes - Hermes.Client","doc":"The initial client <> server handshake is performed automatically when the client is started.","ref":"Hermes.Client.html#module-notes"},{"type":"function","title":"Hermes.Client.call_tool/4","doc":"Calls a tool on the server.","ref":"Hermes.Client.html#call_tool/4"},{"type":"function","title":"Options - Hermes.Client.call_tool/4","doc":"* `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#call_tool/4-options"},{"type":"function","title":"Hermes.Client.cancel_all_requests/2","doc":"Cancels all pending requests.","ref":"Hermes.Client.html#cancel_all_requests/2"},{"type":"function","title":"Parameters - Hermes.Client.cancel_all_requests/2","doc":"* `client` - The client process\n  * `reason` - Optional reason for cancellation (defaults to \"client_cancelled\")","ref":"Hermes.Client.html#cancel_all_requests/2-parameters"},{"type":"function","title":"Returns - Hermes.Client.cancel_all_requests/2","doc":"* `{:ok, requests}` - A list of the Request structs that were cancelled\n  * `{:error, reason}` - If an error occurred","ref":"Hermes.Client.html#cancel_all_requests/2-returns"},{"type":"function","title":"Hermes.Client.cancel_request/3","doc":"Cancels an in-progress request.","ref":"Hermes.Client.html#cancel_request/3"},{"type":"function","title":"Parameters - Hermes.Client.cancel_request/3","doc":"* `client` - The client process\n  * `request_id` - The ID of the request to cancel\n  * `reason` - Optional reason for cancellation","ref":"Hermes.Client.html#cancel_request/3-parameters"},{"type":"function","title":"Returns - Hermes.Client.cancel_request/3","doc":"* `:ok` if the cancellation was successful\n  * `{:error, reason}` if an error occurred\n  * `{:not_found, request_id}` if the request ID was not found","ref":"Hermes.Client.html#cancel_request/3-returns"},{"type":"function","title":"Hermes.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hermes.Client.html#child_spec/1"},{"type":"function","title":"Hermes.Client.close/1","doc":"Closes the client connection and terminates the process.","ref":"Hermes.Client.html#close/1"},{"type":"function","title":"Hermes.Client.get_prompt/4","doc":"Gets a specific prompt from the server.","ref":"Hermes.Client.html#get_prompt/4"},{"type":"function","title":"Options - Hermes.Client.get_prompt/4","doc":"* `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#get_prompt/4-options"},{"type":"function","title":"Hermes.Client.get_schema/1","doc":"","ref":"Hermes.Client.html#get_schema/1"},{"type":"function","title":"Hermes.Client.get_server_capabilities/1","doc":"Gets the server's capabilities as reported during initialization.\n\nReturns `nil` if the client has not been initialized yet.","ref":"Hermes.Client.html#get_server_capabilities/1"},{"type":"function","title":"Hermes.Client.get_server_info/1","doc":"Gets the server's information as reported during initialization.\n\nReturns `nil` if the client has not been initialized yet.","ref":"Hermes.Client.html#get_server_info/1"},{"type":"function","title":"Hermes.Client.list_prompts/2","doc":"Lists available prompts from the server.","ref":"Hermes.Client.html#list_prompts/2"},{"type":"function","title":"Options - Hermes.Client.list_prompts/2","doc":"* `:cursor` - Pagination cursor for continuing a previous request\n  * `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#list_prompts/2-options"},{"type":"function","title":"Hermes.Client.list_resources/2","doc":"Lists available resources from the server.","ref":"Hermes.Client.html#list_resources/2"},{"type":"function","title":"Options - Hermes.Client.list_resources/2","doc":"* `:cursor` - Pagination cursor for continuing a previous request\n  * `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#list_resources/2-options"},{"type":"function","title":"Hermes.Client.list_tools/2","doc":"Lists available tools from the server.","ref":"Hermes.Client.html#list_tools/2"},{"type":"function","title":"Options - Hermes.Client.list_tools/2","doc":"* `:cursor` - Pagination cursor for continuing a previous request\n  * `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#list_tools/2-options"},{"type":"type","title":"Hermes.Client.log_callback/0","doc":"","ref":"Hermes.Client.html#t:log_callback/0"},{"type":"function","title":"Hermes.Client.merge_capabilities/2","doc":"Merges additional capabilities into the client's capabilities.","ref":"Hermes.Client.html#merge_capabilities/2"},{"type":"type","title":"Hermes.Client.option/0","doc":"","ref":"Hermes.Client.html#t:option/0"},{"type":"function","title":"Hermes.Client.parse_options/1","doc":"","ref":"Hermes.Client.html#parse_options/1"},{"type":"function","title":"Hermes.Client.parse_options!/1","doc":"","ref":"Hermes.Client.html#parse_options!/1"},{"type":"function","title":"Hermes.Client.ping/2","doc":"Sends a ping request to the server to check connection health. Returns `:pong` if successful.","ref":"Hermes.Client.html#ping/2"},{"type":"type","title":"Hermes.Client.progress_callback/0","doc":"","ref":"Hermes.Client.html#t:progress_callback/0"},{"type":"function","title":"Hermes.Client.read_resource/3","doc":"Reads a specific resource from the server.","ref":"Hermes.Client.html#read_resource/3"},{"type":"function","title":"Options - Hermes.Client.read_resource/3","doc":"* `:timeout` - Request timeout in milliseconds\n  * `:progress` - Progress tracking options\n    * `:token` - A unique token to track progress (string or integer)\n    * `:callback` - A function to call when progress updates are received","ref":"Hermes.Client.html#read_resource/3-options"},{"type":"function","title":"Hermes.Client.register_log_callback/2","doc":"Registers a callback function to be called when log messages are received.","ref":"Hermes.Client.html#register_log_callback/2"},{"type":"function","title":"Parameters - Hermes.Client.register_log_callback/2","doc":"* `client` - The client process\n  * `callback` - A function that takes three arguments: level, data, and logger name\n\nThe callback function will be called whenever a log message notification is received.","ref":"Hermes.Client.html#register_log_callback/2-parameters"},{"type":"function","title":"Hermes.Client.register_progress_callback/3","doc":"Registers a callback function to be called when progress notifications are received\nfor the specified progress token.","ref":"Hermes.Client.html#register_progress_callback/3"},{"type":"function","title":"Parameters - Hermes.Client.register_progress_callback/3","doc":"* `client` - The client process\n  * `progress_token` - The progress token to watch for (string or integer)\n  * `callback` - A function that takes three arguments: progress_token, progress, and total\n\nThe callback function will be called whenever a progress notification with the\nmatching token is received.","ref":"Hermes.Client.html#register_progress_callback/3-parameters"},{"type":"function","title":"Hermes.Client.send_progress/4","doc":"Sends a progress notification to the server for a long-running operation.","ref":"Hermes.Client.html#send_progress/4"},{"type":"function","title":"Parameters - Hermes.Client.send_progress/4","doc":"* `client` - The client process\n  * `progress_token` - The progress token provided in the original request (string or integer)\n  * `progress` - The current progress value (number)\n  * `total` - The optional total value for the operation (number)\n\nReturns `:ok` if notification was sent successfully, or `{:error, reason}` otherwise.","ref":"Hermes.Client.html#send_progress/4-parameters"},{"type":"function","title":"Hermes.Client.set_log_level/2","doc":"Sets the minimum log level for the server to send log messages.","ref":"Hermes.Client.html#set_log_level/2"},{"type":"function","title":"Parameters - Hermes.Client.set_log_level/2","doc":"* `client` - The client process\n  * `level` - The minimum log level (debug, info, notice, warning, error, critical, alert, emergency)\n\nReturns {:ok, result} if successful, {:error, reason} otherwise.","ref":"Hermes.Client.html#set_log_level/2-parameters"},{"type":"function","title":"Hermes.Client.start_link/1","doc":"Starts a new MCP client process.","ref":"Hermes.Client.html#start_link/1"},{"type":"function","title":"Options - Hermes.Client.start_link/1","doc":"* `:name` - Optional name to register the client process\n  * `:transport` - The transport process or name to use (required)\n  * `:client_info` - Information about the client (required)\n  * `:capabilities` - Client capabilities to advertise\n  * `:protocol_version` - Protocol version to use (defaults to \"2024-11-05\")\n  * `:request_timeout` - Default timeout for requests in milliseconds (default: 30s)","ref":"Hermes.Client.html#start_link/1-options"},{"type":"function","title":"Hermes.Client.unregister_log_callback/1","doc":"Unregisters a previously registered log callback.","ref":"Hermes.Client.html#unregister_log_callback/1"},{"type":"function","title":"Parameters - Hermes.Client.unregister_log_callback/1","doc":"* `client` - The client process\n  * `callback` - The callback function to unregister","ref":"Hermes.Client.html#unregister_log_callback/1-parameters"},{"type":"function","title":"Hermes.Client.unregister_progress_callback/2","doc":"Unregisters a previously registered progress callback for the specified token.","ref":"Hermes.Client.html#unregister_progress_callback/2"},{"type":"function","title":"Parameters - Hermes.Client.unregister_progress_callback/2","doc":"* `client` - The client process\n  * `progress_token` - The progress token to stop watching (string or integer)","ref":"Hermes.Client.html#unregister_progress_callback/2-parameters"},{"type":"module","title":"Hermes.Client.Request","doc":"Represents a pending request in the MCP client.\n\nThis struct encapsulates all information about an in-progress request:\n- `id` - The unique request ID\n- `method` - The MCP method being called\n- `from` - The GenServer caller reference\n- `timer_ref` - Reference to the timeout timer\n- `start_time` - When the request started (monotonic time in milliseconds)","ref":"Hermes.Client.Request.html"},{"type":"function","title":"Hermes.Client.Request.elapsed_time/1","doc":"Calculates the elapsed time for a request in milliseconds.","ref":"Hermes.Client.Request.html#elapsed_time/1"},{"type":"function","title":"Hermes.Client.Request.new/1","doc":"Creates a new request struct.","ref":"Hermes.Client.Request.html#new/1"},{"type":"function","title":"Parameters - Hermes.Client.Request.new/1","doc":"* `attrs` - Map containing the request attributes\n    * `:id` - The unique request ID\n    * `:method` - The MCP method name\n    * `:from` - The GenServer caller reference\n    * `:timer_ref` - Reference to the timeout timer","ref":"Hermes.Client.Request.html#new/1-parameters"},{"type":"type","title":"Hermes.Client.Request.t/0","doc":"","ref":"Hermes.Client.Request.html#t:t/0"},{"type":"module","title":"Hermes.Client.State","doc":"Manages state for the Hermes MCP client.\n\nThis module provides a structured representation of client state,\nincluding capabilities, server info, and request tracking.","ref":"Hermes.Client.State.html"},{"type":"module","title":"State Structure - Hermes.Client.State","doc":"Each client state includes:\n- `client_info`: Information about the client\n- `capabilities`: Client capabilities\n- `server_capabilities`: Server capabilities received during initialization\n- `server_info`: Server information received during initialization\n- `protocol_version`: MCP protocol version being used\n- `request_timeout`: Default timeout for requests\n- `transport`: Transport module or transport info\n- `pending_requests`: Map of pending requests with details and timers\n- `progress_callbacks`: Map of callbacks for progress tracking\n- `log_callback`: Callback for handling log messages","ref":"Hermes.Client.State.html#module-state-structure"},{"type":"module","title":"Examples - Hermes.Client.State","doc":"```elixir\n# Create a new client state\nstate = Hermes.Client.State.new(%{\n  client_info: %{\"name\" => \"MyClient\", \"version\" => \"1.0.0\"},\n  capabilities: %{\"resources\" => %{}},\n  protocol_version: \"2024-11-05\",\n  request_timeout: 30000,\n  transport: %{layer: Hermes.Transport.SSE, name: MyTransport}\n})\n\n# Add a request to the state\n{request_id, updated_state} = Hermes.Client.State.add_request(state, \"ping\", %{}, from)\n\n# Get server capabilities\nserver_capabilities = Hermes.Client.State.get_server_capabilities(state)\n```","ref":"Hermes.Client.State.html#module-examples"},{"type":"function","title":"Hermes.Client.State.add_request/4","doc":"Adds a new request to the state and returns the request ID and updated state.","ref":"Hermes.Client.State.html#add_request/4"},{"type":"function","title":"Parameters - Hermes.Client.State.add_request/4","doc":"* `state` - The current client state\n  * `method` - The method being requested\n  * `params` - The parameters for the request\n  * `from` - The GenServer.from for the caller","ref":"Hermes.Client.State.html#add_request/4-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.add_request/4","doc":"iex> {req_id, updated_state} = Hermes.Client.State.add_request(state, \"ping\", %{}, {pid, ref})\n    iex> is_binary(req_id)\n    true\n    iex> map_size(updated_state.pending_requests) > map_size(state.pending_requests)\n    true","ref":"Hermes.Client.State.html#add_request/4-examples"},{"type":"function","title":"Hermes.Client.State.clear_log_callback/1","doc":"Clears the log callback.","ref":"Hermes.Client.State.html#clear_log_callback/1"},{"type":"function","title":"Parameters - Hermes.Client.State.clear_log_callback/1","doc":"* `state` - The current client state","ref":"Hermes.Client.State.html#clear_log_callback/1-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.clear_log_callback/1","doc":"iex> updated_state = Hermes.Client.State.clear_log_callback(state)\n    iex> is_nil(updated_state.log_callback)\n    true","ref":"Hermes.Client.State.html#clear_log_callback/1-examples"},{"type":"function","title":"Hermes.Client.State.get_log_callback/1","doc":"Gets the log callback.","ref":"Hermes.Client.State.html#get_log_callback/1"},{"type":"function","title":"Parameters - Hermes.Client.State.get_log_callback/1","doc":"* `state` - The current client state","ref":"Hermes.Client.State.html#get_log_callback/1-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.get_log_callback/1","doc":"iex> callback = Hermes.Client.State.get_log_callback(state)\n    iex> is_function(callback, 3) or is_nil(callback)\n    true","ref":"Hermes.Client.State.html#get_log_callback/1-examples"},{"type":"function","title":"Hermes.Client.State.get_progress_callback/2","doc":"Gets a progress callback for a token.","ref":"Hermes.Client.State.html#get_progress_callback/2"},{"type":"function","title":"Parameters - Hermes.Client.State.get_progress_callback/2","doc":"* `state` - The current client state\n  * `token` - The progress token to get the callback for","ref":"Hermes.Client.State.html#get_progress_callback/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.get_progress_callback/2","doc":"iex> callback = Hermes.Client.State.get_progress_callback(state, \"token123\")\n    iex> is_function(callback, 3)\n    true","ref":"Hermes.Client.State.html#get_progress_callback/2-examples"},{"type":"function","title":"Hermes.Client.State.get_request/2","doc":"Gets a request by ID.","ref":"Hermes.Client.State.html#get_request/2"},{"type":"function","title":"Parameters - Hermes.Client.State.get_request/2","doc":"* `state` - The current client state\n  * `id` - The request ID to retrieve","ref":"Hermes.Client.State.html#get_request/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.get_request/2","doc":"iex> Hermes.Client.State.get_request(state, \"req_123\")\n    {{pid, ref}, \"ping\", timer_ref, start_time} # or nil if not found","ref":"Hermes.Client.State.html#get_request/2-examples"},{"type":"function","title":"Hermes.Client.State.get_server_capabilities/1","doc":"Gets the server capabilities.","ref":"Hermes.Client.State.html#get_server_capabilities/1"},{"type":"function","title":"Parameters - Hermes.Client.State.get_server_capabilities/1","doc":"* `state` - The current client state","ref":"Hermes.Client.State.html#get_server_capabilities/1-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.get_server_capabilities/1","doc":"iex> Hermes.Client.State.get_server_capabilities(state)\n    %{\"resources\" => %{}, \"tools\" => %{}}","ref":"Hermes.Client.State.html#get_server_capabilities/1-examples"},{"type":"function","title":"Hermes.Client.State.get_server_info/1","doc":"Gets the server info.","ref":"Hermes.Client.State.html#get_server_info/1"},{"type":"function","title":"Parameters - Hermes.Client.State.get_server_info/1","doc":"* `state` - The current client state","ref":"Hermes.Client.State.html#get_server_info/1-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.get_server_info/1","doc":"iex> Hermes.Client.State.get_server_info(state)\n    %{\"name\" => \"TestServer\", \"version\" => \"1.0.0\"}","ref":"Hermes.Client.State.html#get_server_info/1-examples"},{"type":"function","title":"Hermes.Client.State.handle_request_timeout/2","doc":"Handles a request timeout, cancelling the timer and returning the updated state.","ref":"Hermes.Client.State.html#handle_request_timeout/2"},{"type":"function","title":"Parameters - Hermes.Client.State.handle_request_timeout/2","doc":"* `state` - The current client state\n  * `id` - The request ID that timed out","ref":"Hermes.Client.State.html#handle_request_timeout/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.handle_request_timeout/2","doc":"iex> Hermes.Client.State.handle_request_timeout(state, \"req_123\")\n    {%{from: from, method: \"ping\", elapsed_ms: 30000}, updated_state}","ref":"Hermes.Client.State.html#handle_request_timeout/2-examples"},{"type":"function","title":"Hermes.Client.State.list_pending_requests/1","doc":"Returns a list of all pending requests.","ref":"Hermes.Client.State.html#list_pending_requests/1"},{"type":"function","title":"Parameters - Hermes.Client.State.list_pending_requests/1","doc":"* `state` - The current client state","ref":"Hermes.Client.State.html#list_pending_requests/1-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.list_pending_requests/1","doc":"iex> requests = Hermes.Client.State.list_pending_requests(state)\n    iex> length(requests) > 0\n    true\n    iex> hd(requests).method\n    \"ping\"","ref":"Hermes.Client.State.html#list_pending_requests/1-examples"},{"type":"type","title":"Hermes.Client.State.log_callback/0","doc":"","ref":"Hermes.Client.State.html#t:log_callback/0"},{"type":"function","title":"Hermes.Client.State.merge_capabilities/2","doc":"Merges additional capabilities into the client's capabilities.","ref":"Hermes.Client.State.html#merge_capabilities/2"},{"type":"function","title":"Parameters - Hermes.Client.State.merge_capabilities/2","doc":"* `state` - The current client state\n  * `additional_capabilities` - The capabilities to merge","ref":"Hermes.Client.State.html#merge_capabilities/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.merge_capabilities/2","doc":"iex> updated_state = Hermes.Client.State.merge_capabilities(state, %{\"tools\" => %{\"execute\" => true}})\n    iex> updated_state.capabilities[\"tools\"][\"execute\"]\n    true","ref":"Hermes.Client.State.html#merge_capabilities/2-examples"},{"type":"function","title":"Hermes.Client.State.new/1","doc":"Creates a new client state with the given options.","ref":"Hermes.Client.State.html#new/1"},{"type":"function","title":"Parameters - Hermes.Client.State.new/1","doc":"* `opts` - Map containing the initialization options","ref":"Hermes.Client.State.html#new/1-parameters"},{"type":"function","title":"Options - Hermes.Client.State.new/1","doc":"* `:client_info` - Information about the client (required)\n  * `:capabilities` - Client capabilities to advertise\n  * `:protocol_version` - Protocol version to use\n  * `:request_timeout` - Default timeout for requests in milliseconds\n  * `:transport` - Transport configuration","ref":"Hermes.Client.State.html#new/1-options"},{"type":"function","title":"Examples - Hermes.Client.State.new/1","doc":"iex> Hermes.Client.State.new(%{\n    ...>   client_info: %{\"name\" => \"MyClient\", \"version\" => \"1.0.0\"},\n    ...>   capabilities: %{\"resources\" => %{}},\n    ...>   protocol_version: \"2024-11-05\",\n    ...>   request_timeout: 30000,\n    ...>   transport: %{layer: Hermes.Transport.SSE, name: MyTransport}\n    ...> })\n    %Hermes.Client.State{\n      client_info: %{\"name\" => \"MyClient\", \"version\" => \"1.0.0\"},\n      capabilities: %{\"resources\" => %{}},\n      protocol_version: \"2024-11-05\",\n      request_timeout: 30000,\n      transport: %{layer: Hermes.Transport.SSE, name: MyTransport}\n    }","ref":"Hermes.Client.State.html#new/1-examples"},{"type":"type","title":"Hermes.Client.State.progress_callback/0","doc":"","ref":"Hermes.Client.State.html#t:progress_callback/0"},{"type":"function","title":"Hermes.Client.State.register_progress_callback/3","doc":"Registers a progress callback for a token.","ref":"Hermes.Client.State.html#register_progress_callback/3"},{"type":"function","title":"Parameters - Hermes.Client.State.register_progress_callback/3","doc":"* `state` - The current client state\n  * `token` - The progress token to register a callback for\n  * `callback` - The callback function to call when progress updates are received","ref":"Hermes.Client.State.html#register_progress_callback/3-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.register_progress_callback/3","doc":"iex> updated_state = Hermes.Client.State.register_progress_callback(state, \"token123\", fn token, progress, total -> IO.inspect({token, progress, total}) end)\n    iex> Map.has_key?(updated_state.progress_callbacks, \"token123\")\n    true","ref":"Hermes.Client.State.html#register_progress_callback/3-examples"},{"type":"function","title":"Hermes.Client.State.remove_request/2","doc":"Removes a request and returns its info along with the updated state.","ref":"Hermes.Client.State.html#remove_request/2"},{"type":"function","title":"Parameters - Hermes.Client.State.remove_request/2","doc":"* `state` - The current client state\n  * `id` - The request ID to remove","ref":"Hermes.Client.State.html#remove_request/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.remove_request/2","doc":"iex> {request_info, updated_state} = Hermes.Client.State.remove_request(state, \"req_123\")\n    iex> request_info.method\n    \"ping\"\n    iex> request_info.elapsed_ms > 0\n    true","ref":"Hermes.Client.State.html#remove_request/2-examples"},{"type":"function","title":"Hermes.Client.State.set_log_callback/2","doc":"Sets the log callback.","ref":"Hermes.Client.State.html#set_log_callback/2"},{"type":"function","title":"Parameters - Hermes.Client.State.set_log_callback/2","doc":"* `state` - The current client state\n  * `callback` - The callback function to call when log messages are received","ref":"Hermes.Client.State.html#set_log_callback/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.set_log_callback/2","doc":"iex> updated_state = Hermes.Client.State.set_log_callback(state, fn level, data, logger -> IO.inspect({level, data, logger}) end)\n    iex> is_function(updated_state.log_callback, 3)\n    true","ref":"Hermes.Client.State.html#set_log_callback/2-examples"},{"type":"type","title":"Hermes.Client.State.t/0","doc":"","ref":"Hermes.Client.State.html#t:t/0"},{"type":"function","title":"Hermes.Client.State.unregister_progress_callback/2","doc":"Unregisters a progress callback for a token.","ref":"Hermes.Client.State.html#unregister_progress_callback/2"},{"type":"function","title":"Parameters - Hermes.Client.State.unregister_progress_callback/2","doc":"* `state` - The current client state\n  * `token` - The progress token to unregister the callback for","ref":"Hermes.Client.State.html#unregister_progress_callback/2-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.unregister_progress_callback/2","doc":"iex> updated_state = Hermes.Client.State.unregister_progress_callback(state, \"token123\")\n    iex> Map.has_key?(updated_state.progress_callbacks, \"token123\")\n    false","ref":"Hermes.Client.State.html#unregister_progress_callback/2-examples"},{"type":"function","title":"Hermes.Client.State.update_server_info/3","doc":"Updates server info and capabilities after initialization.","ref":"Hermes.Client.State.html#update_server_info/3"},{"type":"function","title":"Parameters - Hermes.Client.State.update_server_info/3","doc":"* `state` - The current client state\n  * `server_capabilities` - The server capabilities received from initialization\n  * `server_info` - The server information received from initialization","ref":"Hermes.Client.State.html#update_server_info/3-parameters"},{"type":"function","title":"Examples - Hermes.Client.State.update_server_info/3","doc":"iex> updated_state = Hermes.Client.State.update_server_info(state, %{\"resources\" => %{}}, %{\"name\" => \"TestServer\"})\n    iex> updated_state.server_capabilities\n    %{\"resources\" => %{}}\n    iex> updated_state.server_info\n    %{\"name\" => \"TestServer\"}","ref":"Hermes.Client.State.html#update_server_info/3-examples"},{"type":"function","title":"Hermes.Client.State.validate_capability/2","doc":"Validates if a method is supported by the server's capabilities.","ref":"Hermes.Client.State.html#validate_capability/2"},{"type":"function","title":"Parameters - Hermes.Client.State.validate_capability/2","doc":"* `state` - The current client state\n  * `method` - The method to validate","ref":"Hermes.Client.State.html#validate_capability/2-parameters"},{"type":"function","title":"Returns - Hermes.Client.State.validate_capability/2","doc":"* `:ok` if the method is supported\n  * `{:error, %Hermes.MCP.Error{}}` if the method is not supported","ref":"Hermes.Client.State.html#validate_capability/2-returns"},{"type":"function","title":"Examples - Hermes.Client.State.validate_capability/2","doc":"iex> Hermes.Client.State.validate_capability(state_with_resources, \"resources/list\")\n    :ok\n    \n    iex> {:error, error} = Hermes.Client.State.validate_capability(state_without_tools, \"tools/list\")\n    iex> error.reason\n    :method_not_found","ref":"Hermes.Client.State.html#validate_capability/2-examples"},{"type":"module","title":"Hermes.HTTP","doc":"HTTP utilities.","ref":"Hermes.HTTP.html"},{"type":"function","title":"Hermes.HTTP.build/5","doc":"","ref":"Hermes.HTTP.html#build/5"},{"type":"function","title":"Hermes.HTTP.follow_redirect/2","doc":"","ref":"Hermes.HTTP.html#follow_redirect/2"},{"type":"function","title":"Hermes.HTTP.post/3","doc":"Performs a POST request to the given URL.","ref":"Hermes.HTTP.html#post/3"},{"type":"module","title":"Hermes.MCP.Error","doc":"Represents errors in the MCP protocol.\n\nThis module defines standardized error types based on the JSON-RPC 2.0\nerror codes, with additional MCP-specific error reasons.","ref":"Hermes.MCP.Error.html"},{"type":"module","title":"Error Structure - Hermes.MCP.Error","doc":"Each error includes:\n- `code`: Numeric error code (following JSON-RPC 2.0 conventions)\n- `reason`: Atom representing the error type (e.g., `:parse_error`, `:timeout`)\n- `data`: Additional context or metadata about the error","ref":"Hermes.MCP.Error.html#module-error-structure"},{"type":"module","title":"Error Categories - Hermes.MCP.Error","doc":"Errors are categorized into:\n- Standard JSON-RPC errors (parse errors, invalid requests, etc.)\n- Transport errors (connection issues, timeouts)\n- Client errors (request handling issues)\n- Server errors (capability issues, domain errors)","ref":"Hermes.MCP.Error.html#module-error-categories"},{"type":"module","title":"Examples - Hermes.MCP.Error","doc":"```elixir\n# Creating standard RPC errors\nHermes.MCP.Error.parse_error()\n\n# Creating transport errors\nHermes.MCP.Error.transport_error(:connection_refused)\n\n# Creating client errors\nHermes.MCP.Error.client_error(:request_timeout, %{elapsed_ms: 30000})\n\n# Converting from JSON-RPC errors\nHermes.MCP.Error.from_json_rpc(%{\"code\" => -32700, \"message\" => \"Parse error\"})\n```","ref":"Hermes.MCP.Error.html#module-examples"},{"type":"function","title":"Hermes.MCP.Error.client_error/2","doc":"Creates a client-related error.\n\nUsed for errors that occur within the client implementation.","ref":"Hermes.MCP.Error.html#client_error/2"},{"type":"function","title":"Parameters - Hermes.MCP.Error.client_error/2","doc":"* `reason` - Atom representing the specific client error\n  * `data` - Additional error context or metadata","ref":"Hermes.MCP.Error.html#client_error/2-parameters"},{"type":"function","title":"Examples - Hermes.MCP.Error.client_error/2","doc":"iex> Hermes.MCP.Error.client_error(:request_timeout, %{elapsed_ms: 30000})\n    %Hermes.MCP.Error{code: -32000, reason: :request_timeout, data: %{type: :client, elapsed_ms: 30000}}","ref":"Hermes.MCP.Error.html#client_error/2-examples"},{"type":"function","title":"Hermes.MCP.Error.domain_error/1","doc":"Creates a domain-level error from an MCP server response.\n\nUsed for application-level errors returned as valid JSON-RPC responses with `isError: true`.","ref":"Hermes.MCP.Error.html#domain_error/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.domain_error/1","doc":"iex> Hermes.MCP.Error.domain_error(%{\"message\" => \"Resource not found\"})\n    %Hermes.MCP.Error{code: -32000, reason: :domain_error, data: %{\"message\" => \"Resource not found\"}}","ref":"Hermes.MCP.Error.html#domain_error/1-examples"},{"type":"function","title":"Hermes.MCP.Error.from_json_rpc/1","doc":"Converts from a JSON-RPC error object to a Hermes.MCP.Error struct.","ref":"Hermes.MCP.Error.html#from_json_rpc/1"},{"type":"function","title":"Parameters - Hermes.MCP.Error.from_json_rpc/1","doc":"* `error` - A map containing the JSON-RPC error fields","ref":"Hermes.MCP.Error.html#from_json_rpc/1-parameters"},{"type":"function","title":"Examples - Hermes.MCP.Error.from_json_rpc/1","doc":"iex> Hermes.MCP.Error.from_json_rpc(%{\"code\" => -32700, \"message\" => \"Parse error\"})\n    %Hermes.MCP.Error{code: -32700, reason: :parse_error, data: %{original_message: \"Parse error\"}}","ref":"Hermes.MCP.Error.html#from_json_rpc/1-examples"},{"type":"function","title":"Hermes.MCP.Error.internal_error/1","doc":"Creates an internal error.\n\nUsed when an internal server error occurs.","ref":"Hermes.MCP.Error.html#internal_error/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.internal_error/1","doc":"iex> Hermes.MCP.Error.internal_error()\n    %Hermes.MCP.Error{code: -32603, reason: :internal_error, data: %{}}","ref":"Hermes.MCP.Error.html#internal_error/1-examples"},{"type":"function","title":"Hermes.MCP.Error.invalid_params/1","doc":"Creates an invalid params error.\n\nUsed when the parameters provided are invalid for the requested method.","ref":"Hermes.MCP.Error.html#invalid_params/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.invalid_params/1","doc":"iex> Hermes.MCP.Error.invalid_params(%{param: \"name\"})\n    %Hermes.MCP.Error{code: -32602, reason: :invalid_params, data: %{param: \"name\"}}","ref":"Hermes.MCP.Error.html#invalid_params/1-examples"},{"type":"function","title":"Hermes.MCP.Error.invalid_request/1","doc":"Creates an invalid request error.\n\nUsed when the JSON sent is not a valid request object.","ref":"Hermes.MCP.Error.html#invalid_request/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.invalid_request/1","doc":"iex> Hermes.MCP.Error.invalid_request()\n    %Hermes.MCP.Error{code: -32600, reason: :invalid_request, data: %{}}","ref":"Hermes.MCP.Error.html#invalid_request/1-examples"},{"type":"function","title":"Hermes.MCP.Error.method_not_found/1","doc":"Creates a method not found error.\n\nUsed when the requested method does not exist or is not available.","ref":"Hermes.MCP.Error.html#method_not_found/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.method_not_found/1","doc":"iex> Hermes.MCP.Error.method_not_found(%{method: \"unknown_method\"})\n    %Hermes.MCP.Error{code: -32601, reason: :method_not_found, data: %{method: \"unknown_method\"}}","ref":"Hermes.MCP.Error.html#method_not_found/1-examples"},{"type":"function","title":"Hermes.MCP.Error.parse_error/1","doc":"Creates a parse error.\n\nUsed when the server is unable to parse the JSON received.","ref":"Hermes.MCP.Error.html#parse_error/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.parse_error/1","doc":"iex> Hermes.MCP.Error.parse_error()\n    %Hermes.MCP.Error{code: -32700, reason: :parse_error, data: %{}}","ref":"Hermes.MCP.Error.html#parse_error/1-examples"},{"type":"type","title":"Hermes.MCP.Error.t/0","doc":"","ref":"Hermes.MCP.Error.html#t:t/0"},{"type":"function","title":"Hermes.MCP.Error.to_tuple/1","doc":"Converts an MCP error to a tuple of the form `{:error, error}`.\n\nThis is useful for returning errors in functions that follow the \n`{:ok, result} | {:error, reason}` pattern.","ref":"Hermes.MCP.Error.html#to_tuple/1"},{"type":"function","title":"Examples - Hermes.MCP.Error.to_tuple/1","doc":"iex> error = Hermes.MCP.Error.parse_error()\n    iex> Hermes.MCP.Error.to_tuple(error)\n    {:error, %Hermes.MCP.Error{code: -32700, reason: :parse_error, data: %{}}}","ref":"Hermes.MCP.Error.html#to_tuple/1-examples"},{"type":"function","title":"Hermes.MCP.Error.transport_error/2","doc":"Creates a transport-related error.\n\nUsed for communication/network errors between client and server.","ref":"Hermes.MCP.Error.html#transport_error/2"},{"type":"function","title":"Parameters - Hermes.MCP.Error.transport_error/2","doc":"* `reason` - Atom representing the specific transport error\n  * `data` - Additional error context or metadata","ref":"Hermes.MCP.Error.html#transport_error/2-parameters"},{"type":"function","title":"Examples - Hermes.MCP.Error.transport_error/2","doc":"iex> Hermes.MCP.Error.transport_error(:connection_refused)\n    %Hermes.MCP.Error{code: -32000, reason: :connection_refused, data: %{type: :transport}}","ref":"Hermes.MCP.Error.html#transport_error/2-examples"},{"type":"module","title":"Hermes.MCP.ID","doc":"Utilities for working with MCP message identifiers.\n\nThis module provides functions for generating request IDs and progress tokens\nused in the MCP protocol.","ref":"Hermes.MCP.ID.html"},{"type":"module","title":"ID Format - Hermes.MCP.ID","doc":"Generated IDs are Base64-encoded strings containing:\n- Timestamp component (to ensure temporal uniqueness)\n- Process identifier hash (to ensure process-level uniqueness)\n- Random component (to ensure collision resistance)\n\nThis format ensures uniqueness across nodes, processes, and repeated calls.","ref":"Hermes.MCP.ID.html#module-id-format"},{"type":"module","title":"Examples - Hermes.MCP.ID","doc":"```elixir\n# Generate a standard request ID\nrequest_id = Hermes.MCP.ID.generate()\n\n# Generate a progress token\nprogress_token = Hermes.MCP.ID.generate_progress_token()\n```","ref":"Hermes.MCP.ID.html#module-examples"},{"type":"function","title":"Hermes.MCP.ID.generate/0","doc":"Generates a unique request ID.\n\nCreates a Base64 encoded string containing:\n- Timestamp component (nanoseconds)\n- Process identifier hash\n- Random component","ref":"Hermes.MCP.ID.html#generate/0"},{"type":"function","title":"Examples - Hermes.MCP.ID.generate/0","doc":"iex> id = Hermes.MCP.ID.generate()\n    iex> is_binary(id)\n    true","ref":"Hermes.MCP.ID.html#generate/0-examples"},{"type":"function","title":"Hermes.MCP.ID.generate_progress_token/0","doc":"Generates a unique progress token.\n\nCreates a standard request ID with a \"progress_\" prefix for clarity.\nProgress tokens are used in the MCP protocol to track long-running operations.","ref":"Hermes.MCP.ID.html#generate_progress_token/0"},{"type":"function","title":"Examples - Hermes.MCP.ID.generate_progress_token/0","doc":"iex> token = Hermes.MCP.ID.generate_progress_token()\n    iex> String.starts_with?(token, \"progress_\")\n    true","ref":"Hermes.MCP.ID.html#generate_progress_token/0-examples"},{"type":"function","title":"Hermes.MCP.ID.generate_request_id/0","doc":"Generates a unique request ID.\n\nCreates a standard ID with a \"req_\" prefix for clarity.\nRequest IDs are used to correlate requests with their responses.","ref":"Hermes.MCP.ID.html#generate_request_id/0"},{"type":"function","title":"Examples - Hermes.MCP.ID.generate_request_id/0","doc":"iex> id = Hermes.MCP.ID.generate_request_id()\n    iex> String.starts_with?(id, \"req_\")\n    true","ref":"Hermes.MCP.ID.html#generate_request_id/0-examples"},{"type":"function","title":"Hermes.MCP.ID.timestamp_from_id/1","doc":"Extracts timestamp from an ID for debugging purposes.\n\nThis is primarily useful for troubleshooting timing issues or\nanalyzing the sequence of requests.","ref":"Hermes.MCP.ID.html#timestamp_from_id/1"},{"type":"function","title":"Parameters - Hermes.MCP.ID.timestamp_from_id/1","doc":"* `id` - An ID generated by this module","ref":"Hermes.MCP.ID.html#timestamp_from_id/1-parameters"},{"type":"function","title":"Returns - Hermes.MCP.ID.timestamp_from_id/1","doc":"* The timestamp (in nanoseconds) or nil if the ID cannot be parsed","ref":"Hermes.MCP.ID.html#timestamp_from_id/1-returns"},{"type":"function","title":"Examples - Hermes.MCP.ID.timestamp_from_id/1","doc":"iex> id = Hermes.MCP.ID.generate()\n    iex> timestamp = Hermes.MCP.ID.timestamp_from_id(id)\n    iex> is_integer(timestamp)\n    true\n    \n    iex> Hermes.MCP.ID.timestamp_from_id(\"invalid-id\")\n    nil","ref":"Hermes.MCP.ID.html#timestamp_from_id/1-examples"},{"type":"function","title":"Hermes.MCP.ID.valid?/1","doc":"Checks if a string appears to be a valid MCP ID.\n\nThis performs a basic validation to check if the string conforms\nto the expected ID format.","ref":"Hermes.MCP.ID.html#valid?/1"},{"type":"function","title":"Examples - Hermes.MCP.ID.valid?/1","doc":"iex> id = Hermes.MCP.ID.generate()\n    iex> Hermes.MCP.ID.valid?(id)\n    true\n    \n    iex> Hermes.MCP.ID.valid?(\"invalid-id\")\n    false","ref":"Hermes.MCP.ID.html#valid?/1-examples"},{"type":"function","title":"Hermes.MCP.ID.valid_progress_token?/1","doc":"Checks if a string appears to be a valid progress token.\n\nValidates that the string starts with \"progress_\" and the \nremainder is a valid MCP ID.","ref":"Hermes.MCP.ID.html#valid_progress_token?/1"},{"type":"function","title":"Examples - Hermes.MCP.ID.valid_progress_token?/1","doc":"iex> token = Hermes.MCP.ID.generate_progress_token()\n    iex> Hermes.MCP.ID.valid_progress_token?(token)\n    true\n    \n    iex> Hermes.MCP.ID.valid_progress_token?(\"not-a-token\")\n    false","ref":"Hermes.MCP.ID.html#valid_progress_token?/1-examples"},{"type":"function","title":"Hermes.MCP.ID.valid_request_id?/1","doc":"Checks if a string appears to be a valid request ID.\n\nValidates that the string starts with \"req_\" and the \nremainder is a valid MCP ID.","ref":"Hermes.MCP.ID.html#valid_request_id?/1"},{"type":"function","title":"Examples - Hermes.MCP.ID.valid_request_id?/1","doc":"iex> id = Hermes.MCP.ID.generate_request_id()\n    iex> Hermes.MCP.ID.valid_request_id?(id)\n    true\n    \n    iex> Hermes.MCP.ID.valid_request_id?(\"not-an-id\")\n    false","ref":"Hermes.MCP.ID.html#valid_request_id?/1-examples"},{"type":"module","title":"Hermes.MCP.Message","doc":"Handles encoding and decoding of MCP protocol messages.\n\nThis module provides functions for parsing, validating, and creating\nMCP (Model Context Protocol) messages using the JSON-RPC 2.0 format.","ref":"Hermes.MCP.Message.html"},{"type":"module","title":"Message Types - Hermes.MCP.Message","doc":"The MCP protocol uses JSON-RPC 2.0 messages in these forms:\n\n1. Requests - Messages sent from client to server that expect a response\n2. Responses - Messages sent from server to client in response to a request\n3. Notifications - Messages sent in either direction that don't expect a response\n4. Errors - Error responses sent from server to client","ref":"Hermes.MCP.Message.html#module-message-types"},{"type":"module","title":"Examples - Hermes.MCP.Message","doc":"```elixir\n# Decode MCP messages from a string\n{:ok, messages} = Hermes.MCP.Message.decode(json_string)\n\n# Encode a request\n{:ok, request_json} = Hermes.MCP.Message.encode_request(%{\"method\" => \"ping\", \"params\" => %{}}, \"req_123\")\n\n# Encode a notification\n{:ok, notif_json} = Hermes.MCP.Message.encode_notification(%{\"method\" => \"notifications/progress\", \"params\" => %{...}})\n```","ref":"Hermes.MCP.Message.html#module-examples"},{"type":"function","title":"Hermes.MCP.Message.decode/1","doc":"Decodes a JSON string into MCP message(s).\n\nThis function handles both single messages and newline-delimited message streams.","ref":"Hermes.MCP.Message.html#decode/1"},{"type":"function","title":"Parameters - Hermes.MCP.Message.decode/1","doc":"* `data` - The JSON string to decode","ref":"Hermes.MCP.Message.html#decode/1-parameters"},{"type":"function","title":"Returns - Hermes.MCP.Message.decode/1","doc":"* `{:ok, messages}` where messages is a list of parsed MCP messages\n  * `{:error, error}` if parsing fails","ref":"Hermes.MCP.Message.html#decode/1-returns"},{"type":"function","title":"Examples - Hermes.MCP.Message.decode/1","doc":"iex> Hermes.MCP.Message.decode(~s({\"jsonrpc\":\"2.0\",\"result\":{},\"id\":\"req_123\"}))\n    {:ok, [%{\"jsonrpc\" => \"2.0\", \"result\" => %{}, \"id\" => \"req_123\"}]}\n    \n    iex> {:error, error} = Hermes.MCP.Message.decode(\"invalid\")\n    iex> error.code\n    -32700\n    iex> error.reason\n    :parse_error","ref":"Hermes.MCP.Message.html#decode/1-examples"},{"type":"function","title":"Hermes.MCP.Message.encode_notification/1","doc":"Encodes a notification message into a JSON-RPC 2.0 compliant string.","ref":"Hermes.MCP.Message.html#encode_notification/1"},{"type":"function","title":"Parameters - Hermes.MCP.Message.encode_notification/1","doc":"* `notification` - A map containing the notification method and params","ref":"Hermes.MCP.Message.html#encode_notification/1-parameters"},{"type":"function","title":"Returns - Hermes.MCP.Message.encode_notification/1","doc":"* `{:ok, json_string}` with the encoded notification and a newline\n  * `{:error, error}` if encoding fails","ref":"Hermes.MCP.Message.html#encode_notification/1-returns"},{"type":"function","title":"Examples - Hermes.MCP.Message.encode_notification/1","doc":"iex> {:ok, notif} = Hermes.MCP.Message.encode_notification(%{\"method\" => \"notifications/progress\", \"params\" => %{\"progress\" => 50}})\n    iex> notif_map = notif |> String.trim() |> JSON.decode!()\n    iex> notif_map[\"jsonrpc\"]\n    \"2.0\"\n    iex> notif_map[\"method\"]\n    \"notifications/progress\"\n    iex> notif_map[\"params\"][\"progress\"]\n    50","ref":"Hermes.MCP.Message.html#encode_notification/1-examples"},{"type":"function","title":"Hermes.MCP.Message.encode_progress_notification/3","doc":"Encodes a progress notification message.","ref":"Hermes.MCP.Message.html#encode_progress_notification/3"},{"type":"function","title":"Parameters - Hermes.MCP.Message.encode_progress_notification/3","doc":"* `progress_token` - The token that was provided in the original request (string or integer)\n  * `progress` - The current progress value (number)\n  * `total` - Optional total value for the operation (number)","ref":"Hermes.MCP.Message.html#encode_progress_notification/3-parameters"},{"type":"function","title":"Returns - Hermes.MCP.Message.encode_progress_notification/3","doc":"* `{:ok, json_string}` with the encoded notification and a newline\n  * `{:error, error}` if encoding fails","ref":"Hermes.MCP.Message.html#encode_progress_notification/3-returns"},{"type":"function","title":"Examples - Hermes.MCP.Message.encode_progress_notification/3","doc":"iex> {:ok, notif} = Hermes.MCP.Message.encode_progress_notification(\"token123\", 50)\n    iex> notif_map = notif |> String.trim() |> JSON.decode!()\n    iex> notif_map[\"method\"]\n    \"notifications/progress\"\n    iex> notif_map[\"params\"][\"progressToken\"]\n    \"token123\"\n    iex> notif_map[\"params\"][\"progress\"]\n    50","ref":"Hermes.MCP.Message.html#encode_progress_notification/3-examples"},{"type":"function","title":"Hermes.MCP.Message.encode_request/2","doc":"Encodes a request message into a JSON-RPC 2.0 compliant string.","ref":"Hermes.MCP.Message.html#encode_request/2"},{"type":"function","title":"Parameters - Hermes.MCP.Message.encode_request/2","doc":"* `request` - A map containing the request method and params\n  * `id` - A unique identifier for the request","ref":"Hermes.MCP.Message.html#encode_request/2-parameters"},{"type":"function","title":"Returns - Hermes.MCP.Message.encode_request/2","doc":"* `{:ok, json_string}` with the encoded request and a newline\n  * `{:error, error}` if encoding fails","ref":"Hermes.MCP.Message.html#encode_request/2-returns"},{"type":"function","title":"Examples - Hermes.MCP.Message.encode_request/2","doc":"iex> {:ok, request} = Hermes.MCP.Message.encode_request(%{\"method\" => \"ping\", \"params\" => %{}}, \"req_123\")\n    iex> request_map = request |> String.trim() |> JSON.decode!()\n    iex> request_map[\"jsonrpc\"]\n    \"2.0\"\n    iex> request_map[\"method\"]\n    \"ping\"\n    iex> request_map[\"id\"]\n    \"req_123\"","ref":"Hermes.MCP.Message.html#encode_request/2-examples"},{"type":"macro","title":"Hermes.MCP.Message.is_error/1","doc":"","ref":"Hermes.MCP.Message.html#is_error/1"},{"type":"macro","title":"Hermes.MCP.Message.is_notification/1","doc":"","ref":"Hermes.MCP.Message.html#is_notification/1"},{"type":"macro","title":"Hermes.MCP.Message.is_request/1","doc":"","ref":"Hermes.MCP.Message.html#is_request/1"},{"type":"macro","title":"Hermes.MCP.Message.is_response/1","doc":"","ref":"Hermes.MCP.Message.html#is_response/1"},{"type":"type","title":"Hermes.MCP.Message.message/0","doc":"Represents any MCP protocol message.\n\nMCP protocol uses JSON-RPC 2.0 with several message formats:\n\n1. Request Message:\n   ```\n   {\n     \"jsonrpc\": \"2.0\",\n     \"method\": String, // Method name like \"ping\", \"resources/list\"\n     \"params\": Object, // Method parameters\n     \"id\": String|Number // Request identifier\n   }\n   ```\n\n2. Notification Message:\n   ```\n   {\n     \"jsonrpc\": \"2.0\",\n     \"method\": String, // Method name like \"notifications/progress\"\n     \"params\": Object  // Notification parameters\n   }\n   ```\n\n3. Response Message:\n   ```\n   {\n     \"jsonrpc\": \"2.0\",\n     \"result\": Object, // Result value\n     \"id\": String|Number // Request identifier\n   }\n   ```\n\n4. Error Message:\n   ```\n   {\n     \"jsonrpc\": \"2.0\",\n     \"error\": {\n       \"code\": Number,    // Error code\n       \"message\": String, // Error message\n       \"data\": Any        // Optional error data\n     },\n     \"id\": String|Number // Request identifier\n   }\n   ```","ref":"Hermes.MCP.Message.html#t:message/0"},{"type":"function","title":"Hermes.MCP.Message.to_domain/1","doc":"Converts a message to the appropriate domain object based on its type.","ref":"Hermes.MCP.Message.html#to_domain/1"},{"type":"function","title":"Parameters - Hermes.MCP.Message.to_domain/1","doc":"* `message` - A parsed JSON-RPC 2.0 message","ref":"Hermes.MCP.Message.html#to_domain/1-parameters"},{"type":"function","title":"Returns - Hermes.MCP.Message.to_domain/1","doc":"* `{:ok, domain_object}` with the appropriate type (Response or Error)\n  * `{:error, error}` if conversion fails","ref":"Hermes.MCP.Message.html#to_domain/1-returns"},{"type":"function","title":"Examples - Hermes.MCP.Message.to_domain/1","doc":"iex> resp = %{\"jsonrpc\" => \"2.0\", \"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"}\n    iex> {:ok, response} = Hermes.MCP.Message.to_domain(resp)\n    iex> response.__struct__\n    Hermes.MCP.Response\n    \n    iex> err = %{\"jsonrpc\" => \"2.0\", \"error\" => %{\"code\" => -32700, \"message\" => \"Parse error\"}, \"id\" => \"req_123\"}\n    iex> {:ok, error} = Hermes.MCP.Message.to_domain(err)\n    iex> error.__struct__\n    Hermes.MCP.Error","ref":"Hermes.MCP.Message.html#to_domain/1-examples"},{"type":"function","title":"Hermes.MCP.Message.validate/1","doc":"Validates a message according to the MCP protocol.\n\nPerforms basic validation to ensure the message conforms to the JSON-RPC 2.0\nstructure and has valid MCP-specific fields.","ref":"Hermes.MCP.Message.html#validate/1"},{"type":"function","title":"Parameters - Hermes.MCP.Message.validate/1","doc":"* `message` - The parsed JSON message to validate","ref":"Hermes.MCP.Message.html#validate/1-parameters"},{"type":"function","title":"Returns - Hermes.MCP.Message.validate/1","doc":"* `:ok` if the message is valid\n  * `{:error, error}` if validation fails","ref":"Hermes.MCP.Message.html#validate/1-returns"},{"type":"function","title":"Examples - Hermes.MCP.Message.validate/1","doc":"iex> Hermes.MCP.Message.validate(%{\"jsonrpc\" => \"2.0\", \"result\" => %{}, \"id\" => \"req_123\"})\n    :ok\n    \n    iex> {:error, error} = Hermes.MCP.Message.validate(%{\"jsonrpc\" => \"1.0\", \"result\" => %{}, \"id\" => \"req_123\"})\n    iex> error.reason\n    :invalid_request","ref":"Hermes.MCP.Message.html#validate/1-examples"},{"type":"module","title":"Hermes.MCP.Response","doc":"Represents successful responses in the MCP protocol.\n\nThis module provides a wrapper around JSON-RPC responses, handling\ndomain-specific error semantics for MCP's \"isError\" field in results.","ref":"Hermes.MCP.Response.html"},{"type":"module","title":"Response Structure - Hermes.MCP.Response","doc":"Each response includes:\n- `result`: The response data from the server\n- `id`: The request ID this response is associated with\n- `is_error`: Boolean flag indicating if this is a domain-level error","ref":"Hermes.MCP.Response.html#module-response-structure"},{"type":"module","title":"Domain vs. Protocol Errors - Hermes.MCP.Response","doc":"The MCP protocol distinguishes between two types of errors:\n\n1. Protocol errors: Standard JSON-RPC errors with error codes (handled by `Hermes.MCP.Error`)\n2. Domain errors: Valid responses that indicate application-level errors with `isError: true`\n\nThis module specifically handles domain errors, which are successful at the protocol level\nbut indicate failures at the application level.","ref":"Hermes.MCP.Response.html#module-domain-vs-protocol-errors"},{"type":"module","title":"Examples - Hermes.MCP.Response","doc":"```elixir\n# Create from a JSON-RPC response\nresponse = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"})\n\n# Check if the response is successful or has a domain error\nif Hermes.MCP.Response.success?(response) do\n  # Handle success\nelse\n  # Handle domain error\nend\n\n# Unwrap the response to get the result or error\ncase Hermes.MCP.Response.unwrap(response) do\n  {:ok, result} -> # Handle success\n  {:error, error} -> # Handle domain error\nend\n```","ref":"Hermes.MCP.Response.html#module-examples"},{"type":"function","title":"Hermes.MCP.Response.error?/1","doc":"Checks if the response has a domain error.","ref":"Hermes.MCP.Response.html#error?/1"},{"type":"function","title":"Examples - Hermes.MCP.Response.error?/1","doc":"iex> response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.error?(response)\n    false\n    \n    iex> error_response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"isError\" => true}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.error?(error_response)\n    true","ref":"Hermes.MCP.Response.html#error?/1-examples"},{"type":"function","title":"Hermes.MCP.Response.from_json_rpc/1","doc":"Creates a Response struct from a JSON-RPC response.\n\nAutomatically detects domain errors by checking for the \"isError\" field.","ref":"Hermes.MCP.Response.html#from_json_rpc/1"},{"type":"function","title":"Parameters - Hermes.MCP.Response.from_json_rpc/1","doc":"* `response` - A map containing the JSON-RPC response","ref":"Hermes.MCP.Response.html#from_json_rpc/1-parameters"},{"type":"function","title":"Examples - Hermes.MCP.Response.from_json_rpc/1","doc":"iex> Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{}, \"id\" => \"req_123\"})\n    %Hermes.MCP.Response{result: %{}, id: \"req_123\", is_error: false}\n    \n    iex> Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"isError\" => true}, \"id\" => \"req_123\"})\n    %Hermes.MCP.Response{result: %{\"isError\" => true}, id: \"req_123\", is_error: true}","ref":"Hermes.MCP.Response.html#from_json_rpc/1-examples"},{"type":"function","title":"Hermes.MCP.Response.get_id/1","doc":"Gets the request ID associated with this response.","ref":"Hermes.MCP.Response.html#get_id/1"},{"type":"function","title":"Examples - Hermes.MCP.Response.get_id/1","doc":"iex> response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.get_id(response)\n    \"req_123\"","ref":"Hermes.MCP.Response.html#get_id/1-examples"},{"type":"function","title":"Hermes.MCP.Response.get_result/1","doc":"Gets the result data from the response.\n\nThis function returns the raw result regardless of whether it represents\na success or domain error.","ref":"Hermes.MCP.Response.html#get_result/1"},{"type":"function","title":"Examples - Hermes.MCP.Response.get_result/1","doc":"iex> response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.get_result(response)\n    %{\"data\" => \"value\"}","ref":"Hermes.MCP.Response.html#get_result/1-examples"},{"type":"function","title":"Hermes.MCP.Response.success?/1","doc":"Checks if the response is successful (no domain error).","ref":"Hermes.MCP.Response.html#success?/1"},{"type":"function","title":"Examples - Hermes.MCP.Response.success?/1","doc":"iex> response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.success?(response)\n    true\n    \n    iex> error_response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"isError\" => true}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.success?(error_response)\n    false","ref":"Hermes.MCP.Response.html#success?/1-examples"},{"type":"type","title":"Hermes.MCP.Response.t/0","doc":"","ref":"Hermes.MCP.Response.html#t:t/0"},{"type":"function","title":"Hermes.MCP.Response.unwrap/1","doc":"Unwraps the response, returning the raw result.\n\nReturns the raw result data regardless of whether it represents\na success or domain error.","ref":"Hermes.MCP.Response.html#unwrap/1"},{"type":"function","title":"Examples - Hermes.MCP.Response.unwrap/1","doc":"iex> response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"data\" => \"value\"}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.unwrap(response)\n    %{\"data\" => \"value\"}\n    \n    iex> error_response = Hermes.MCP.Response.from_json_rpc(%{\"result\" => %{\"isError\" => true, \"reason\" => \"not_found\"}, \"id\" => \"req_123\"})\n    iex> Hermes.MCP.Response.unwrap(error_response)\n    %{\"isError\" => true, \"reason\" => \"not_found\"}","ref":"Hermes.MCP.Response.html#unwrap/1-examples"},{"type":"module","title":"Hermes.Message","doc":"Handles parsing and validation of MCP (Model Context Protocol) messages using the Peri library.\n\nThis module provides functions to parse and validate MCP messages based on the Model Context Protocol schema","ref":"Hermes.Message.html"},{"type":"function","title":"Hermes.Message.decode/1","doc":"Decodes raw data (possibly containing multiple messages) into JSON-RPC messages.\n\nReturns either:\n- `{:ok, messages}` where messages is a list of parsed JSON-RPC messages\n- `{:error, reason}` if parsing fails","ref":"Hermes.Message.html#decode/1"},{"type":"function","title":"Hermes.Message.encode_log_message/3","doc":"Encodes a log message notification to be sent to the client.","ref":"Hermes.Message.html#encode_log_message/3"},{"type":"function","title":"Parameters - Hermes.Message.encode_log_message/3","doc":"* `level` - The log level (debug, info, notice, warning, error, critical, alert, emergency)\n  * `data` - The data to be logged (any JSON-serializable value)\n  * `logger` - Optional name of the logger issuing the message\n\nReturns the encoded notification string with a newline character appended.","ref":"Hermes.Message.html#encode_log_message/3-parameters"},{"type":"function","title":"Hermes.Message.encode_notification/1","doc":"Encodes a notification message to a JSON-RPC 2.0 compliant string.\n\nReturns the encoded string with a newline character appended.","ref":"Hermes.Message.html#encode_notification/1"},{"type":"function","title":"Hermes.Message.encode_progress_notification/3","doc":"Encodes a progress notification message to a JSON-RPC 2.0 compliant string.","ref":"Hermes.Message.html#encode_progress_notification/3"},{"type":"function","title":"Parameters - Hermes.Message.encode_progress_notification/3","doc":"* `progress_token` - The token that was provided in the original request (string or integer)\n  * `progress` - The current progress value (number)\n  * `total` - Optional total value for the operation (number)\n\nReturns the encoded string with a newline character appended.","ref":"Hermes.Message.html#encode_progress_notification/3-parameters"},{"type":"function","title":"Hermes.Message.encode_request/2","doc":"Encodes a request message to a JSON-RPC 2.0 compliant string.\n\nReturns the encoded string with a newline character appended.","ref":"Hermes.Message.html#encode_request/2"},{"type":"function","title":"Hermes.Message.encode_response/2","doc":"Encodes a response message to a JSON-RPC 2.0 compliant string.\n\nReturns the encoded string with a newline character appended.","ref":"Hermes.Message.html#encode_response/2"},{"type":"function","title":"Hermes.Message.error_schema/1","doc":"","ref":"Hermes.Message.html#error_schema/1"},{"type":"function","title":"Hermes.Message.error_schema!/1","doc":"","ref":"Hermes.Message.html#error_schema!/1"},{"type":"function","title":"Hermes.Message.generate_progress_token/0","doc":"Generates a unique progress token that can be used for tracking progress.\n\nThis is a convenience function to create tokens for the progress notification system.\nReturns a string token with \"progress_\" prefix followed by a Base64-encoded unique identifier.","ref":"Hermes.Message.html#generate_progress_token/0"},{"type":"function","title":"Hermes.Message.get_schema/1","doc":"","ref":"Hermes.Message.html#get_schema/1"},{"type":"macro","title":"Hermes.Message.is_error/1","doc":"Determines if a JSON-RPC message is an error.","ref":"Hermes.Message.html#is_error/1"},{"type":"macro","title":"Hermes.Message.is_notification/1","doc":"Determines if a JSON-RPC message is a notification.","ref":"Hermes.Message.html#is_notification/1"},{"type":"macro","title":"Hermes.Message.is_request/1","doc":"Determines if a JSON-RPC message is a request.","ref":"Hermes.Message.html#is_request/1"},{"type":"macro","title":"Hermes.Message.is_response/1","doc":"Determines if a JSON-RPC message is a response.","ref":"Hermes.Message.html#is_response/1"},{"type":"function","title":"Hermes.Message.mcp_message_schema/1","doc":"","ref":"Hermes.Message.html#mcp_message_schema/1"},{"type":"function","title":"Hermes.Message.mcp_message_schema!/1","doc":"","ref":"Hermes.Message.html#mcp_message_schema!/1"},{"type":"function","title":"Hermes.Message.notification_schema/1","doc":"","ref":"Hermes.Message.html#notification_schema/1"},{"type":"function","title":"Hermes.Message.notification_schema!/1","doc":"","ref":"Hermes.Message.html#notification_schema!/1"},{"type":"function","title":"Hermes.Message.request_schema/1","doc":"","ref":"Hermes.Message.html#request_schema/1"},{"type":"function","title":"Hermes.Message.request_schema!/1","doc":"","ref":"Hermes.Message.html#request_schema!/1"},{"type":"function","title":"Hermes.Message.response_schema/1","doc":"","ref":"Hermes.Message.html#response_schema/1"},{"type":"function","title":"Hermes.Message.response_schema!/1","doc":"","ref":"Hermes.Message.html#response_schema!/1"},{"type":"function","title":"Hermes.Message.validate_message/1","doc":"Validates a decoded JSON message to ensure it complies with the MCP schema.","ref":"Hermes.Message.html#validate_message/1"},{"type":"module","title":"Hermes.SSE","doc":"Server-Sent Events (SSE) utilities, HTTP client abstraction and HTTP streaming handling.","ref":"Hermes.SSE.html"},{"type":"function","title":"Hermes.SSE.connect/3","doc":"Connects to a server-sent event stream.","ref":"Hermes.SSE.html#connect/3"},{"type":"function","title":"Parameters - Hermes.SSE.connect/3","doc":"- `server_url` - the URL of the server to connect to.\n  - `headers` - additional headers to send with the request.\n  - `opts` - additional options to pass to the HTTP client.","ref":"Hermes.SSE.html#connect/3-parameters"},{"type":"function","title":"Examples - Hermes.SSE.connect/3","doc":"iex> Hermes.SSE.connect(\"http://localhost:4000\")\n    #Stream<[ref: 1, task: #PID<0.123.0>]>","ref":"Hermes.SSE.html#connect/3-examples"},{"type":"module","title":"Hermes.SSE.Event","doc":"Represents a Server-Sent Event.\n\nFields:\n  - `:id`    - identifier of the event (if any)\n  - `:event` - event type (defaults to \"message\")\n  - `:data`  - the event data (concatenates multiple data lines with a newline)\n  - `:retry` - reconnection time (parsed as integer, if provided)","ref":"Hermes.SSE.Event.html"},{"type":"type","title":"Hermes.SSE.Event.t/0","doc":"","ref":"Hermes.SSE.Event.html#t:t/0"},{"type":"module","title":"Hermes.SSE.Parser","doc":"Parses a raw SSE stream into a list of `%SSE.Event{}` structs.","ref":"Hermes.SSE.Parser.html"},{"type":"function","title":"Hermes.SSE.Parser.run/1","doc":"Parses a string containing one or more SSE events.\n\nEach event is separated by an empty line (two consecutive newlines).\nReturns a list of `%SSE.Event{}` structs.","ref":"Hermes.SSE.Parser.html#run/1"},{"type":"behaviour","title":"Hermes.Transport.Behaviour","doc":"Defines the behavior that all transport implementations must follow.","ref":"Hermes.Transport.Behaviour.html"},{"type":"type","title":"Hermes.Transport.Behaviour.message/0","doc":"","ref":"Hermes.Transport.Behaviour.html#t:message/0"},{"type":"type","title":"Hermes.Transport.Behaviour.reason/0","doc":"","ref":"Hermes.Transport.Behaviour.html#t:reason/0"},{"type":"callback","title":"Hermes.Transport.Behaviour.send_message/2","doc":"","ref":"Hermes.Transport.Behaviour.html#c:send_message/2"},{"type":"callback","title":"Hermes.Transport.Behaviour.shutdown/1","doc":"","ref":"Hermes.Transport.Behaviour.html#c:shutdown/1"},{"type":"callback","title":"Hermes.Transport.Behaviour.start_link/1","doc":"","ref":"Hermes.Transport.Behaviour.html#c:start_link/1"},{"type":"type","title":"Hermes.Transport.Behaviour.t/0","doc":"","ref":"Hermes.Transport.Behaviour.html#t:t/0"},{"type":"module","title":"Hermes.Transport.SSE","doc":"A transport implementation that uses Server-Sent Events (SSE) for receiving messages\nand HTTP POST requests for sending messages back to the server.","ref":"Hermes.Transport.SSE.html"},{"type":"module","title":"Examples - Hermes.Transport.SSE","doc":"iex> Hermes.Transport.SSE.start_link(server_url: \"http://localhost:4000\")\n    {:ok, #PID<0.123.0>}\n\n    iex> Hermes.Transport.SSE.send_message(pid, \"Hello, world!\")","ref":"Hermes.Transport.SSE.html#module-examples"},{"type":"module","title":"Options - Hermes.Transport.SSE","doc":"The options schema for the SSE transport.\n\n- `name`: The name of the transport.\n- `client`: The client process to send messages to.\n- `server_url`: The URL of the server to connect to.\n- `headers`: Additional headers to send with the HTTP requests.\n- `transport_opts`: Additional options as keyword to pass to the HTTP client, you can reference the available options at https://hexdocs.pm/mint/Mint.HTTP.html#connect/4-transport-options\n- `http_options`: Additional HTTP request options as keyword to pass to the HTTP client, you can check the available options on https://hexdocs.pm/finch/Finch.html#t:request_opt/0","ref":"Hermes.Transport.SSE.html#module-options"},{"type":"function","title":"Hermes.Transport.SSE.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hermes.Transport.SSE.html#child_spec/1"},{"type":"function","title":"Hermes.Transport.SSE.get_schema/1","doc":"","ref":"Hermes.Transport.SSE.html#get_schema/1"},{"type":"type","title":"Hermes.Transport.SSE.option/0","doc":"","ref":"Hermes.Transport.SSE.html#t:option/0"},{"type":"function","title":"Hermes.Transport.SSE.options_schema/1","doc":"","ref":"Hermes.Transport.SSE.html#options_schema/1"},{"type":"function","title":"Hermes.Transport.SSE.options_schema!/1","doc":"","ref":"Hermes.Transport.SSE.html#options_schema!/1"},{"type":"type","title":"Hermes.Transport.SSE.params_t/0","doc":"","ref":"Hermes.Transport.SSE.html#t:params_t/0"},{"type":"module","title":"Hermes.Transport.STDIO","doc":"A transport implementation that uses standard input/output.","ref":"Hermes.Transport.STDIO.html"},{"type":"function","title":"Hermes.Transport.STDIO.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hermes.Transport.STDIO.html#child_spec/1"},{"type":"function","title":"Hermes.Transport.STDIO.get_schema/1","doc":"","ref":"Hermes.Transport.STDIO.html#get_schema/1"},{"type":"type","title":"Hermes.Transport.STDIO.option/0","doc":"","ref":"Hermes.Transport.STDIO.html#t:option/0"},{"type":"function","title":"Hermes.Transport.STDIO.options_schema/1","doc":"","ref":"Hermes.Transport.STDIO.html#options_schema/1"},{"type":"function","title":"Hermes.Transport.STDIO.options_schema!/1","doc":"","ref":"Hermes.Transport.STDIO.html#options_schema!/1"},{"type":"type","title":"Hermes.Transport.STDIO.params_t/0","doc":"","ref":"Hermes.Transport.STDIO.html#t:params_t/0"},{"type":"module","title":"Hermes.URI","doc":"URI utilities for handling URL paths consistently.","ref":"Hermes.URI.html"},{"type":"function","title":"Hermes.URI.join_path/2","doc":"Joins a base URI with a path segment, handling trailing and leading slashes correctly.","ref":"Hermes.URI.html#join_path/2"},{"type":"function","title":"Examples - Hermes.URI.join_path/2","doc":"iex> Hermes.URI.join_path(URI.new!(\"http://localhost:8000\"), \"/mcp\")\n    %URI{scheme: \"http\", host: \"localhost\", port: 8000, path: \"/mcp\"}\n    \n    iex> Hermes.URI.join_path(URI.new!(\"http://localhost:8000/\"), \"/mcp\")\n    %URI{scheme: \"http\", host: \"localhost\", port: 8000, path: \"/mcp\"}\n    \n    iex> Hermes.URI.join_path(URI.new!(\"http://localhost:8000/api\"), \"/mcp\")\n    %URI{scheme: \"http\", host: \"localhost\", port: 8000, path: \"/api/mcp\"}","ref":"Hermes.URI.html#join_path/2-examples"},{"type":"function","title":"Hermes.URI.join_paths/2","doc":"Joins a base URI with multiple path segments, handling trailing and leading slashes correctly.","ref":"Hermes.URI.html#join_paths/2"},{"type":"module","title":"Mix.Interactive.CLI","doc":"Standalone CLI application for Hermes MCP interactive shells.\n\nThis module serves as the entry point for the standalone binary compiled with Burrito.\nIt can start either the SSE or STDIO interactive shell based on command-line arguments.","ref":"Mix.Interactive.CLI.html"},{"type":"function","title":"Mix.Interactive.CLI.main/1","doc":"Main entry point for the standalone CLI application.","ref":"Mix.Interactive.CLI.html#main/1"},{"type":"module","title":"Mix.Interactive.Commands","doc":"Common command implementations for interactive MCP shells.\n\nThis module contains the implementation of all commands available in the \ninteractive MCP shells. It provides a consistent set of commands across\ndifferent transport implementations, with shared functionality for:\n\n- Listing available commands\n- Fetching and displaying tools, prompts, and resources\n- Calling tools and getting prompts\n- Handling user input and error cases\n- Formatting and displaying results\n\nEach command follows a similar pattern, receiving client and loop function\nreferences to enable proper continuation of the interactive shell.","ref":"Mix.Interactive.Commands.html"},{"type":"function","title":"Mix.Interactive.Commands.commands/0","doc":"Returns the map of available commands and their descriptions.","ref":"Mix.Interactive.Commands.html#commands/0"},{"type":"function","title":"Mix.Interactive.Commands.process_command/3","doc":"Process a command entered by the user.","ref":"Mix.Interactive.Commands.html#process_command/3"},{"type":"module","title":"Mix.Interactive.Shell","doc":"Base functionality for interactive MCP shells.\n\nThis module acts as the core command loop for interactive MCP shells,\nproviding a consistent interface and user experience across different\ntransport implementations (SSE, STDIO).\n\nIt handles basic functionality like reading user input and delegating\ncommand processing to the appropriate handlers.","ref":"Mix.Interactive.Shell.html"},{"type":"function","title":"Mix.Interactive.Shell.loop/1","doc":"Main command loop for interactive shells.","ref":"Mix.Interactive.Shell.html#loop/1"},{"type":"module","title":"Mix.Interactive.UI","doc":"Common UI elements and formatting functions for interactive MCP shells.\n\nThis module provides consistent UI components and formatting helpers for\nthe interactive CLI interfaces used by the Hermes MCP mix tasks.\n\nIt includes functions for displaying colored text, formatted headers,\npretty-printing of data structures, and consistent output formatting.","ref":"Mix.Interactive.UI.html"},{"type":"function","title":"Mix.Interactive.UI.colors/0","doc":"Returns the color configuration map for styling output.","ref":"Mix.Interactive.UI.html#colors/0"},{"type":"function","title":"Mix.Interactive.UI.format_output/1","doc":"Formats JSON or other data for pretty-printing with indentation.","ref":"Mix.Interactive.UI.html#format_output/1"},{"type":"function","title":"Mix.Interactive.UI.header/1","doc":"Creates a styled header for an interactive session.","ref":"Mix.Interactive.UI.html#header/1"},{"type":"function","title":"Mix.Interactive.UI.print_error/1","doc":"Formats error messages with appropriate styling.","ref":"Mix.Interactive.UI.html#print_error/1"},{"type":"function","title":"Mix.Interactive.UI.print_items/3","doc":"Formats lists of tools/prompts/resources with helpful styling.","ref":"Mix.Interactive.UI.html#print_items/3"},{"type":"task","title":"mix hermes.sse.interactive","doc":"Mix task to test the SSE transport implementation, interactively sending commands.","ref":"Mix.Tasks.Hermes.Sse.Interactive.html"},{"type":"task","title":"Options - mix hermes.sse.interactive","doc":"* `--base-url` - Base URL for the SSE server (default: http://localhost:8000)\n* `--base-path` - Base path to append to the base URL\n* `--sse-path` - Specific SSE endpoint path","ref":"Mix.Tasks.Hermes.Sse.Interactive.html#module-options"},{"type":"function","title":"Mix.Tasks.Hermes.Sse.Interactive.run/1","doc":"","ref":"Mix.Tasks.Hermes.Sse.Interactive.html#run/1"},{"type":"task","title":"mix hermes.stdio.interactive","doc":"Mix task to test the STDIO transport implementation, interactively sending commands.","ref":"Mix.Tasks.Hermes.Stdio.Interactive.html"},{"type":"task","title":"Options - mix hermes.stdio.interactive","doc":"* `--command` - Command to execute for the STDIO transport (default: \"mcp\")\n* `--args` - Comma-separated arguments for the command (default: \"run,priv/dev/echo/index.py\")","ref":"Mix.Tasks.Hermes.Stdio.Interactive.html#module-options"},{"type":"function","title":"Mix.Tasks.Hermes.Stdio.Interactive.run/1","doc":"","ref":"Mix.Tasks.Hermes.Stdio.Interactive.html#run/1"},{"type":"extras","title":"Hermes MCP","doc":"# Hermes MCP\n\n[![hex.pm](https://img.shields.io/hexpm/v/hermes_mcp.svg)](https://hex.pm/packages/hermes_mcp)\n[![docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/hermes_mcp)\n[![ci](https://github.com/cloudwalk/hermes-mcp/actions/workflows/ci.yml/badge.svg)](https://github.com/cloudwalk/hermes-mcp/actions/workflows/ci.yml)\n\n> [!WARNING]\n>\n> This library is under active development, may expect breaking changes\n\nA high-performance Model Context Protocol (MCP) implementation in Elixir.","ref":"readme.html"},{"type":"extras","title":"Overview - Hermes MCP","doc":"Hermes MCP provides a robust client implementation for the [Model Context Protocol](https://spec.modelcontextprotocol.io/specification/2024-11-05/), leveraging Elixir's exceptional concurrency model and fault tolerance capabilities.","ref":"readme.html#overview"},{"type":"extras","title":"Features - Hermes MCP","doc":"- Complete client implementation with protocol lifecycle management\n- Multiple transport options (STDIO and HTTP/SSE)\n- Built-in connection supervision and automatic recovery\n- Comprehensive capability negotiation\n- Progress notification support for tracking long-running operations\n- Structured logging system with log level control","ref":"readme.html#features"},{"type":"extras","title":"Installation - Hermes MCP","doc":"","ref":"readme.html#installation"},{"type":"extras","title":"Library Usage - Hermes MCP","doc":"Add Hermes MCP to your dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:hermes_mcp, \"~> 0.3\"}\n  ]\nend\n```","ref":"readme.html#library-usage"},{"type":"extras","title":"Standalone CLI Installation - Hermes MCP","doc":"You can use Hermes MCP CLI in one of the following ways:\n\n#### Option 1: Using Pre-built Binaries\n\nDownload the appropriate binary for your platform from the [GitHub releases page](https://github.com/cloudwalk/hermes-mcp/releases).\n\n```bash\n# Make it executable (Linux/macOS)\n# or hermes_cli-macos-intel, hermes_cli-macos-arm\nmv hermes_mcp_linux hermes-mcp && chmod +x hermes-mcp\n\n# Run it\n./hermes-mcp --transport sse --base-url=\"http://localhost:8000\"\n```\n\n#### Option 2: Mix Archive (For Elixir Developers)\n\n```bash\nmix archive.install hex hermes_mcp\n```\n\nThis makes the mix tasks available globally.","ref":"readme.html#standalone-cli-installation"},{"type":"extras","title":"Quick Start - Hermes MCP","doc":"","ref":"readme.html#quick-start"},{"type":"extras","title":"Interactive Testing - Hermes MCP","doc":"Hermes MCP provides interactive tools for testing MCP servers with a user-friendly CLI.\n\n#### Using the CLI Binary:\n\n```bash\n# Test an SSE server\nhermes_cli --transport sse --base-url=\"http://localhost:8000\" --base-path=\"/mcp\"\n\n# Test a local process via STDIO\nhermes_cli --transport stdio --command=\"mcp\" --args=\"run,path/to/server.py\"\n```\n\n#### Using Mix Tasks (For Elixir Developers):\n\n```bash\n# Test an SSE server\nmix hermes.sse.interactive --base-url=\"http://localhost:8000\" --base-path=\"/mcp\"\n\n# Test a local process via STDIO\nmix hermes.stdio.interactive --command=\"mcp\" --args=\"run,path/to/server.py\"\n```\n\nThese interactive shells provide commands for listing and calling tools, exploring prompts, and accessing resources.","ref":"readme.html#interactive-testing"},{"type":"extras","title":"Setting up a Client - Hermes MCP","doc":"```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      # Start the MCP transport\n      {Hermes.Transport.STDIO, [\n        name: MyApp.MCPTransport,\n        client: MyApp.MCPClient, \n        command: \"mcp\",\n        args: [\"run\", \"path/to/server.py\"]\n      ]},\n      \n      # Start the MCP client using the transport\n      {Hermes.Client, [\n        name: MyApp.MCPClient,\n        transport: [layer: Hermes.Transport.STDIO, name: MyApp.MCPTransport],\n        client_info: %{\n          \"name\" => \"MyApp\",\n          \"version\" => \"1.0.0\"\n        },\n        capabilities: %{\n          \"roots\" => %{},\n          \"sampling\" => %{}\n        }\n      ]}\n    ]\n    \n    opts = [strategy: :one_for_all, name: MyApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"readme.html#setting-up-a-client"},{"type":"extras","title":"Making Client Requests - Hermes MCP","doc":"```elixir\n# Call a tool\n{:ok, result} = Hermes.Client.call_tool(MyApp.MCPClient, \"example_tool\", %{\"param\" => \"value\"})\n\n# Handle errors properly\ncase Hermes.Client.call_tool(MyApp.MCPClient, \"unavailable_tool\", %{}) do\n  {:ok, %Hermes.MCP.Response{}} ->\n    # Handle successful result\n    \n  {:error, %Hermes.MCP.Error{} = err} ->\n    # Handle error response\n    IO.puts(inspect(err, pretty: true))\nend\n```","ref":"readme.html#making-client-requests"},{"type":"extras","title":"Documentation - Hermes MCP","doc":"For detailed guides and examples, visit the [official documentation](https://hexdocs.pm/hermes_mcp)","ref":"readme.html#documentation"},{"type":"extras","title":"Why Hermes? - Hermes MCP","doc":"The library is named after Hermes, the Greek god of boundaries, communication, and commerce. This namesake reflects the core purpose of the Model Context Protocol: to establish standardized communication between AI applications and external tools.\n\nLike Hermes who served as a messenger between gods and mortals, this library facilitates seamless interaction between Large Language Models and various data sources or tools.","ref":"readme.html#why-hermes"},{"type":"extras","title":"License - Hermes MCP","doc":"Hermes MCP is released under the MIT License. See [LICENSE](./LICENSE) for details.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project are documented in this file.\n\n## [0.3.3](https://github.com/cloudwalk/hermes-mcp) - 2025-03-20","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Client request cancellation support (#35)\n- Improved URI path handling for SSE transport (#36)\n- Enhanced interactive mix tasks for testing MCP servers (#34)\n\n## [0.3.2](https://github.com/cloudwalk/hermes-mcp) - 2025-03-19","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Ship static binaries to use hermes-mcp as standlone application\n\n## [0.3.1](https://github.com/cloudwalk/hermes-mcp) - 2025-03-19","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Ship interactive mix tasks `stdio.interactive` and `sse.interactive` to test MCP servers\n\n## [0.3.0](https://github.com/cloudwalk/hermes-mcp) - 2025-03-18","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Structured server-client logging support (#27)\n- Progress notification tracking (#26)\n- MCP domain model implementation (#28)\n- Comprehensive SSE unit tests (#20)\n- Centralized state management (#31)\n- Standardized error response handling (#32)","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Improved domain error handling (#33)\n\n## [0.2.3](https://github.com/cloudwalk/hermes-mcp) - 2025-03-12","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Enhanced SSE transport with graceful shutdown capabilities (#25)\n- Improved SSE streaming with automatic reconnection handling (#25)\n\n## [0.2.2](https://github.com/cloudwalk/hermes-mcp) - 2025-03-05","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Support for multiple concurrent client <> transport pairs (#24)\n- Improved client resource management\n\n## [0.2.1](https://github.com/cloudwalk/hermes-mcp) - 2025-02-28","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Support for custom base and SSE paths in HTTP/SSE client (#19)\n- Enhanced configuration options for SSE endpoints\n\n## [0.2.0](https://github.com/cloudwalk/hermes-mcp) - 2025-02-27","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Implemented HTTP/SSE transport (#7)\n  - Support for server-sent events communication\n  - HTTP client integration for MCP protocol\n  - Streaming response handling","ref":"changelog.html#added"},{"type":"extras","title":"Documentation - Changelog","doc":"- Extensive guides and documentation improvements\n\n## [0.1.0](https://github.com/cloudwalk/hermes-mcp) - 2025-02-26","ref":"changelog.html#documentation"},{"type":"extras","title":"Added - Changelog","doc":"- Implemented STDIO transport (#1) for MCP communication\n  - Support for bidirectional communication via standard I/O\n  - Automatic process monitoring and recovery\n  - Environment variable handling for cross-platform support\n  - Integration test utilities in Mix tasks\n\n- Created stateful client interface (#6)\n  - Robust GenServer implementation for MCP client\n  - Automatic initialization and protocol handshake\n  - Synchronous-feeling API over asynchronous transport\n  - Support for all MCP operations (ping, resources, prompts, tools)\n  - Proper error handling and logging\n  - Capability negotiation and management\n\n- Developed JSON-RPC message parsing (#5)\n  - Schema-based validation of MCP messages\n  - Support for requests, responses, notifications, and errors\n  - Comprehensive test suite for message handling\n  - Encoding/decoding functions with proper validation\n\n- Established core architecture and client API\n  - MCP protocol implementation following specification\n  - Client struct for maintaining connection state\n  - Request/response correlation with unique IDs\n  - Initial transport abstraction layer","ref":"changelog.html#added"},{"type":"extras","title":"Documentation - Changelog","doc":"- Added detailed RFC document describing the library architecture\n- Enhanced README with project overview and installation instructions","ref":"changelog.html#documentation"},{"type":"extras","title":"LICENSE","doc":"Copyright 2025 zoedsoupe  \n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"Hermes MCP","doc":"# Hermes MCP\n\nA high-performance Model Context Protocol (MCP) implementation in Elixir with first-class Phoenix support.","ref":"home.html"},{"type":"extras","title":"Overview - Hermes MCP","doc":"Hermes MCP provides a unified solution for building both MCP clients and servers in Elixir, leveraging the language's exceptional concurrency model and fault tolerance capabilities. The library currently focuses on a robust client implementation, with server functionality planned for future releases.","ref":"home.html#overview"},{"type":"extras","title":"Implementation Status - Hermes MCP","doc":"- ✅ Complete client implementation with protocol lifecycle management\n- ✅ STDIO transport for local process communication\n- ✅ HTTP/SSE transport for production-ready and async process communication\n- ✅ Comprehensive capability negotiation\n- ✅ Robust error handling and recovery\n- 🔄 Phoenix integration (in progress)\n- 🔄 Full server implementation (planned)","ref":"home.html#implementation-status"},{"type":"extras","title":"Protocol Compliance - Hermes MCP","doc":"Hermes MCP implements the [Model Context Protocol specification](https://spec.modelcontextprotocol.io/specification/2024-11-05/), ensuring interoperability with other MCP-compliant tools and services. The library handles all aspects of the MCP lifecycle, from initialization and capability negotiation to request routing and response handling.","ref":"home.html#protocol-compliance"},{"type":"extras","title":"Why Hermes? - Hermes MCP","doc":"The library is named after Hermes, the Greek god of boundaries, communication, and commerce. This namesake reflects the core purpose of the Model Context Protocol: to establish standardized communication between AI applications and external tools. Like Hermes who served as a messenger between gods and mortals, this library facilitates seamless interaction between Large Language Models and various data sources or tools.\n\nFurthermore, Hermes was known for his speed and reliability in delivering messages, which aligns with our implementation's focus on high performance and fault tolerance in the Elixir ecosystem.","ref":"home.html#why-hermes"},{"type":"extras","title":"Installation & Setup","doc":"# Installation & Setup\n\nSetting up Hermes MCP for your Elixir project involves a few straightforward steps.","ref":"installation.html"},{"type":"extras","title":"Adding the Dependency - Installation & Setup","doc":"Add Hermes MCP to your dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:hermes_mcp, \"~> 0.2.0\"}\n  ]\nend\n```\n\nThen run:\n\n```shell\nmix deps.get\n```","ref":"installation.html#adding-the-dependency"},{"type":"extras","title":"Supervision Tree Integration - Installation & Setup","doc":"Hermes MCP is designed to be integrated into your application's supervision tree. This provides robust lifecycle management and automatic recovery in case of failures.","ref":"installation.html#supervision-tree-integration"},{"type":"extras","title":"Basic Integration Example - Installation & Setup","doc":"```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      # Start the MCP transport\n      {Hermes.Transport.STDIO, [\n        name: MyApp.MCPTransport,\n        client: MyApp.MCPClient, \n        command: \"mcp\",\n        args: [\"run\", \"path/to/server.py\"]\n      ]},\n      \n      # Start the MCP client using the transport\n      {Hermes.Client, [\n        name: MyApp.MCPClient,\n        transport: MyApp.MCPTransport,\n        client_info: %{\n          \"name\" => \"MyApp\",\n          \"version\" => \"1.0.0\"\n        },\n        capabilities: %{\n          \"resources\" => %{},\n          \"tools\" => %{},\n          \"prompts\" => %{}\n        }\n      ]}\n      \n      # Your other application services\n      # ...\n    ]\n    \n    opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"installation.html#basic-integration-example"},{"type":"extras","title":"Configuration Options - Installation & Setup","doc":"","ref":"installation.html#configuration-options"},{"type":"extras","title":"Client Configuration - Installation & Setup","doc":"The `Hermes.Client` accepts the following options:\n\n| Option | Type | Description | Default |\n|--------|------|-------------|---------|\n| `:name` | atom | Registration name for the client process | `__MODULE__` |\n| `:transport` | module or pid | The transport module or process | Required |\n| `:client_info` | map | Information about the client | Required |\n| `:capabilities` | map | Client capabilities to advertise | `%{\"resources\" => %{}, \"tools\" => %{}}` |\n| `:protocol_version` | string | Protocol version to use | `\"2024-11-05\"` |\n| `:request_timeout` | integer | Default timeout for requests in milliseconds | 30000 |","ref":"installation.html#client-configuration"},{"type":"extras","title":"Transport Configuration - Installation & Setup","doc":"The `Hermes.Transport.STDIO` accepts the following options:\n\n| Option | Type | Description | Default |\n|--------|------|-------------|---------|\n| `:name` | atom | Registration name for the transport process | `__MODULE__` |\n| `:client` | atom or pid | The client process that will receive messages | Required |\n| `:command` | string | The command to execute | Required |\n| `:args` | list | Command line arguments | `nil` |\n| `:env` | map | Environment variables | System defaults |\n| `:cwd` | string | Working directory | Current directory |","ref":"installation.html#transport-configuration"},{"type":"extras","title":"Environment Requirements - Installation & Setup","doc":"- Elixir 1.18 or later\n- Erlang/OTP 26 or later","ref":"installation.html#environment-requirements"},{"type":"extras","title":"Client Usage Guide","doc":"# Client Usage Guide\n\nThis guide covers the basic usage patterns for the Hermes MCP client.","ref":"client_usage.html"},{"type":"extras","title":"Client Lifecycle - Client Usage Guide","doc":"Once properly configured in your application's supervision tree, the Hermes client automatically handles:\n\n1. Initial connection to the server\n2. Protocol version negotiation\n3. Capability exchange\n4. Handshake completion","ref":"client_usage.html#client-lifecycle"},{"type":"extras","title":"Basic Operations - Client Usage Guide","doc":"","ref":"client_usage.html#basic-operations"},{"type":"extras","title":"Checking Connection Status - Client Usage Guide","doc":"You can check if a server is responsive with the `ping/1` function:\n\n```elixir\ncase Hermes.Client.ping(MyApp.MCPClient) do\n  :pong -> IO.puts(\"Server is responsive\")\n  {:error, reason} -> IO.puts(\"Connection error: #{inspect(reason)}\")\nend\n```","ref":"client_usage.html#checking-connection-status"},{"type":"extras","title":"Retrieving Server Information - Client Usage Guide","doc":"After initialization, you can access the server's capabilities and information:\n\n```elixir\n# Get server capabilities\nserver_capabilities = Hermes.Client.get_server_capabilities(MyApp.MCPClient)\nIO.inspect(server_capabilities, label: \"Server capabilities\")\n\n# Get server version information\nserver_info = Hermes.Client.get_server_info(MyApp.MCPClient)\nIO.inspect(server_info, label: \"Server info\")\n```","ref":"client_usage.html#retrieving-server-information"},{"type":"extras","title":"Working with Resources - Client Usage Guide","doc":"","ref":"client_usage.html#working-with-resources"},{"type":"extras","title":"Listing Resources - Client Usage Guide","doc":"To retrieve the list of available resources from the server:\n\n```elixir\ncase Hermes.Client.list_resources(MyApp.MCPClient) do\n  {:ok, %{\"resources\" => resources}} ->\n    IO.puts(\"Available resources:\")\n    Enum.each(resources, fn resource ->\n      IO.puts(\"  - #{resource[\"name\"]} (#{resource[\"uri\"]})\")\n    end)\n    \n  {:error, error} ->\n    IO.puts(\"Error listing resources: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#listing-resources"},{"type":"extras","title":"Pagination - Client Usage Guide","doc":"For large resource collections, you can use pagination with cursors:\n\n```elixir\n# First page\n{:ok, %{\"resources\" => resources, \"nextCursor\" => cursor}} = \n  Hermes.Client.list_resources(MyApp.MCPClient)\n\n# Get next page if a cursor is available\nif cursor do\n  {:ok, %{\"resources\" => more_resources}} = \n    Hermes.Client.list_resources(MyApp.MCPClient, cursor: cursor)\nend\n```","ref":"client_usage.html#pagination"},{"type":"extras","title":"Reading Resources - Client Usage Guide","doc":"To read the contents of a specific resource:\n\n```elixir\ncase Hermes.Client.read_resource(MyApp.MCPClient, \"file:///example.txt\") do\n  {:ok, %{\"contents\" => contents}} ->\n    Enum.each(contents, fn content ->\n      case content do\n        %{\"text\" => text} -> IO.puts(\"Text content: #{text}\")\n        %{\"blob\" => blob} -> IO.puts(\"Binary content: #{byte_size(blob)} bytes\")\n      end\n    end)\n    \n  {:error, error} ->\n    IO.puts(\"Error reading resource: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#reading-resources"},{"type":"extras","title":"Working with Tools - Client Usage Guide","doc":"","ref":"client_usage.html#working-with-tools"},{"type":"extras","title":"Listing Tools - Client Usage Guide","doc":"To discover available tools:\n\n```elixir\ncase Hermes.Client.list_tools(MyApp.MCPClient) do\n  {:ok, %{\"tools\" => tools}} ->\n    IO.puts(\"Available tools:\")\n    Enum.each(tools, fn tool ->\n      IO.puts(\"  - #{tool[\"name\"]}: #{tool[\"description\"] || \"No description\"}\")\n    end)\n    \n  {:error, error} ->\n    IO.puts(\"Error listing tools: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#listing-tools"},{"type":"extras","title":"Calling Tools - Client Usage Guide","doc":"To invoke a tool with arguments:\n\n```elixir\ntool_name = \"calculate\"\ntool_args = %{\"expression\" => \"2 + 2\"}\n\ncase Hermes.Client.call_tool(MyApp.MCPClient, tool_name, tool_args) do\n  {:ok, %{\"content\" => content, \"isError\" => false}} ->\n    IO.puts(\"Tool result:\")\n    Enum.each(content, fn item ->\n      case item do\n        %{\"type\" => \"text\", \"text\" => text} -> IO.puts(\"  #{text}\")\n        _ -> IO.puts(\"  #{inspect(item)}\")\n      end\n    end)\n    \n  {:ok, %{\"content\" => content, \"isError\" => true}} ->\n    IO.puts(\"Tool execution error:\")\n    Enum.each(content, fn item ->\n      case item do\n        %{\"type\" => \"text\", \"text\" => text} -> IO.puts(\"  #{text}\")\n        _ -> IO.puts(\"  #{inspect(item)}\")\n      end\n    end)\n    \n  {:error, error} ->\n    IO.puts(\"Error calling tool: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#calling-tools"},{"type":"extras","title":"Working with Prompts - Client Usage Guide","doc":"","ref":"client_usage.html#working-with-prompts"},{"type":"extras","title":"Listing Prompts - Client Usage Guide","doc":"To list available prompts:\n\n```elixir\ncase Hermes.Client.list_prompts(MyApp.MCPClient) do\n  {:ok, %{\"prompts\" => prompts}} ->\n    IO.puts(\"Available prompts:\")\n    Enum.each(prompts, fn prompt ->\n      required_args = prompt[\"arguments\"] \n                      |> Enum.filter(& &1[\"required\"])\n                      |> Enum.map(& &1[\"name\"])\n                      |> Enum.join(\", \")\n      \n      IO.puts(\"  - #{prompt[\"name\"]}\")\n      IO.puts(\"    Required args: #{required_args}\")\n    end)\n    \n  {:error, error} ->\n    IO.puts(\"Error listing prompts: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#listing-prompts"},{"type":"extras","title":"Getting Prompts - Client Usage Guide","doc":"To retrieve a specific prompt with arguments:\n\n```elixir\nprompt_name = \"code_review\"\nprompt_args = %{\"code\" => \"def hello():\\n    print('world')\"}\n\ncase Hermes.Client.get_prompt(MyApp.MCPClient, prompt_name, prompt_args) do\n  {:ok, %{\"messages\" => messages}} ->\n    IO.puts(\"Prompt messages:\")\n    Enum.each(messages, fn message ->\n      role = message[\"role\"]\n      content = case message[\"content\"] do\n        %{\"type\" => \"text\", \"text\" => text} -> text\n        _ -> inspect(message[\"content\"])\n      end\n      \n      IO.puts(\"  #{role}: #{content}\")\n    end)\n    \n  {:error, error} ->\n    IO.puts(\"Error getting prompt: #{inspect(error)}\")\nend\n```","ref":"client_usage.html#getting-prompts"},{"type":"extras","title":"Error Handling - Client Usage Guide","doc":"Hermes follows a consistent pattern for error handling:\n\n```elixir\ncase Hermes.Client.some_operation(MyApp.MCPClient, args) do\n  {:ok, result} ->\n    # Handle successful result\n    \n  {:error, %{\"code\" => code, \"message\" => message}} ->\n    # Handle protocol-level error\n    IO.puts(\"Protocol error #{code}: #{message}\")\n    \n  {:error, {:transport_error, reason}} ->\n    # Handle transport-level error\n    IO.puts(\"Transport error: #{inspect(reason)}\")\n    \n  {:error, other_error} ->\n    # Handle other errors\n    IO.puts(\"Unexpected error: #{inspect(other_error)}\")\nend\n```","ref":"client_usage.html#error-handling"},{"type":"extras","title":"Timeouts and Cancellation - Client Usage Guide","doc":"You can specify custom timeouts for operations:\n\n```elixir\n# Use a custom timeout (in milliseconds)\nHermes.Client.call_tool(MyApp.MCPClient, \"slow_tool\", %{}, timeout: 60_000)\n```","ref":"client_usage.html#timeouts-and-cancellation"},{"type":"extras","title":"Extended Capabilities - Client Usage Guide","doc":"To extend the client's capabilities after initialization:\n\n```elixir\n# Add sampling capability\nnew_capabilities = %{\"sampling\" => %{}}\nupdated_capabilities = Hermes.Client.merge_capabilities(MyApp.MCPClient, new_capabilities)\n```","ref":"client_usage.html#extended-capabilities"},{"type":"extras","title":"Graceful Shutdown - Client Usage Guide","doc":"To gracefully close a client connection:\n\n```elixir\nHermes.Client.close(MyApp.MCPClient)\n```","ref":"client_usage.html#graceful-shutdown"},{"type":"extras","title":"Transport Options","doc":"# Transport Options\n\nHermes MCP supports multiple transport mechanisms to connect clients with servers. This page covers the available options and how to configure them.","ref":"transport_options.html"},{"type":"extras","title":"Transport Behavior - Transport Options","doc":"All transports in Hermes implement the `Hermes.Transport.Behaviour` behavior, which defines the interface for sending and receiving messages:\n\n```elixir\ndefmodule Hermes.Transport.Behaviour do\n  @type t :: pid() | atom()\n\n  @typedoc \"encoded JSON-RPC message\"\n  @type message :: String.t()\n\n  @callback start_link(keyword()) :: Supervisor.on_start()\n  @callback send_message(message()) :: :ok | {:error, reason()}\n  @callback send_message(t(), message()) :: :ok | {:error, reason()}\n  @callback shutdown(t()) :: :ok | {:error, reason()}\n  \n  @optional_callbacks send_message: 1\nend\n```\n\nThis standardized interface allows the client to work with different transport mechanisms interchangeably.","ref":"transport_options.html#transport-behavior"},{"type":"extras","title":"STDIO Transport - Transport Options","doc":"The STDIO transport (`Hermes.Transport.STDIO`) enables communication with an MCP server running as a separate process. It's suitable for local integrations and communicates through standard input/output streams.","ref":"transport_options.html#stdio-transport"},{"type":"extras","title":"Configuration - Transport Options","doc":"```elixir\n{Hermes.Transport.STDIO, [\n  name: MyApp.MCPTransport,\n  client: MyApp.MCPClient, \n  command: \"mcp\",\n  args: [\"run\", \"path/to/server.py\"],\n  env: %{\"CUSTOM_VAR\" => \"value\"},\n  cwd: \"/path/to/working/directory\"\n]}\n```","ref":"transport_options.html#configuration"},{"type":"extras","title":"Configuration Options - Transport Options","doc":"| Option | Type | Description | Default |\n|--------|------|-------------|---------|\n| `:name` | atom | Registration name for the transport process | `__MODULE__` |\n| `:client` | atom or pid | The client process that will receive messages | Required |\n| `:command` | string | The command to execute | Required |\n| `:args` | list | Command line arguments | `nil` |\n| `:env` | map | Environment variables | System defaults |\n| `:cwd` | string | Working directory | Current directory |","ref":"transport_options.html#configuration-options"},{"type":"extras","title":"Example: Running a Python MCP Server - Transport Options","doc":"```elixir\n{Hermes.Transport.STDIO, [\n  name: MyApp.MCPTransport,\n  client: MyApp.MCPClient, \n  command: \"python\",\n  args: [\"-m\", \"mcp.server\", \"my_server.py\"],\n  env: %{\"PYTHONPATH\" => \"/path/to/python/modules\"}\n]}\n```","ref":"transport_options.html#example-running-a-python-mcp-server"},{"type":"extras","title":"Example: Running a Node.js MCP Server - Transport Options","doc":"```elixir\n{Hermes.Transport.STDIO, [\n  name: MyApp.MCPTransport,\n  client: MyApp.MCPClient, \n  command: \"node\",\n  args: [\"server.js\"],\n  env: %{\"NODE_ENV\" => \"production\"}\n]}\n```","ref":"transport_options.html#example-running-a-node-js-mcp-server"},{"type":"extras","title":"HTTP/SSE Transport - Transport Options","doc":"Support for HTTP with Server-Sent Events (SSE) transport is planned for future releases. This will enable communication with remote MCP servers over HTTP.","ref":"transport_options.html#http-sse-transport"},{"type":"extras","title":"Configuration - Transport Options","doc":"```elixir\n{Hermes.Transport.HTTP, [\n  name: MyApp.HTTPTransport,\n  client: MyApp.MCPClient,\n  server: [\n    base_url: \"https://example.com\",\n    base_path: \"/mcp\", # defaults to \"/\"\n    sse_path: \"/sse\" # defaults to \"/sse\"\n  ],\n  headers: [{\"Authorization\", \"Bearer token\"}],\n  transport_opts: [verify: :verify_peer],\n  http_options: [recv_timeout: 30_000]\n]}\n```","ref":"transport_options.html#configuration"},{"type":"extras","title":"Configuration Options - Transport Options","doc":"| Option | Type | Description | Default |\n|--------|------|-------------|---------|\n| `:name` | atom | Registration name for the transport process | `__MODULE__` |\n| `:client` | atom or pid | The client process that will receive messages | Required |\n| `:server` | keyword | The SSE server config | Required |\n| `:server.base_url` | string | The SSE server base url | Required |\n| `:server.base_path` | string | The SSE server base path | `\"/\"`|\n| `:server.sse_path` | string | The SSE server base path for starting a SSE connection | `\"/sse\"`|\n| `:headers` | map | Additional request headers to be sent | `%{}` |\n| `:transport_opts` | keyword | Options to be passed to the underlying HTTP Client, yo ucan check the avaiable options on https://hexdocs.pm/mint/Mint.HTTP.html#connect/4-transport-options | System defaults |\n| `:http_options` | string | Options passed directly to the HTTP Client, you can check the available options on https://hexdocs.pm/finch/Finch.html#t:request_opt/0 | Current directory |","ref":"transport_options.html#configuration-options"},{"type":"extras","title":"Custom Transport Implementation - Transport Options","doc":"You can implement custom transports by creating a module that implements the `Hermes.Transport.Behaviour` behavior.","ref":"transport_options.html#custom-transport-implementation"},{"type":"extras","title":"Example: Custom TCP Transport - Transport Options","doc":"```elixir\ndefmodule MyApp.Transport.TCP do\n  @behaviour Hermes.Transport.Behaviour\n  use GenServer\n  \n  @impl true\n  def start_link(opts) do\n    GenServer.start_link(__MODULE__, opts, name: opts[:name])\n  end\n  \n  @impl true\n  def send_message(message) when is_binary(message) do\n    GenServer.call(__MODULE__, {:send, message})\n  end\n  \n  @impl true\n  def send_message(pid, message) when is_pid(pid) and is_binary(message) do\n    GenServer.call(pid, {:send, message})\n  end\n  \n  @impl true\n  def init(opts) do\n    client = opts[:client]\n    host = opts[:host] || \"localhost\"\n    port = opts[:port] || 8080\n    \n    case :gen_tcp.connect(String.to_charlist(host), port, [:binary, active: true]) do\n      {:ok, socket} ->\n        {:ok, %{socket: socket, client: client}}\n        \n      {:error, reason} ->\n        {:stop, reason}\n    end\n  end\n  \n  @impl true\n  def handle_call({:send, message}, _from, %{socket: socket} = state) do\n    case :gen_tcp.send(socket, message) do\n      :ok -> {:reply, :ok, state}\n      {:error, reason} -> {:reply, {:error, reason}, state}\n    end\n  end\n  \n  @impl true\n  def handle_info({:tcp, _socket, data}, %{client: client} = state) do\n    # Forward data to client\n    Process.send(client, {:response, data}, [:noconnect])\n    {:noreply, state}\n  end\n  \n  @impl true\n  def handle_info({:tcp_closed, _socket}, state) do\n    {:stop, :normal, state}\n  end\n  \n  @impl true\n  def handle_info({:tcp_error, _socket, reason}, state) do\n    {:stop, reason, state}\n  end\nend\n```","ref":"transport_options.html#example-custom-tcp-transport"},{"type":"extras","title":"Transport Selection Guidelines - Transport Options","doc":"When choosing a transport mechanism, consider:\n\n1. **Location**: For local servers, STDIO is typically the simplest and most efficient option.\n2. **Security**: For remote servers, HTTP/SSE with TLS provides secure communication.\n3. **Performance**: STDIO generally has lower latency for local communication.\n4. **Reliability**: HTTP transports can handle intermittent network issues more gracefully.","ref":"transport_options.html#transport-selection-guidelines"},{"type":"extras","title":"Transport Lifecycle Management - Transport Options","doc":"Transports in Hermes are designed to be supervised, with automatic recovery in case of failures:\n\n```elixir\n# In your supervision tree\nchildren = [\n  {Hermes.Transport.STDIO, transport_opts},\n  {Hermes.Client, client_opts},\n  # ...\n]\n\n# The transport will automatically restart if it crashes\nopts = [strategy: :one_for_one]\nSupervisor.start_link(children, opts)\n```","ref":"transport_options.html#transport-lifecycle-management"},{"type":"extras","title":"Message Handling","doc":"# Message Handling\n\nThis guide explains how Hermes MCP handles the flow of messages between clients and servers, including request/response patterns, notifications, and error handling.","ref":"message_handling.html"},{"type":"extras","title":"Message Types - Message Handling","doc":"Hermes implements all the standard JSON-RPC 2.0 message types as defined in the MCP specification:\n\n1. **Requests**: Messages with a method, parameters, and ID that expect a response\n2. **Responses**: Successful results or errors matching a specific request ID\n3. **Notifications**: One-way messages with no response expected","ref":"message_handling.html#message-types"},{"type":"extras","title":"Message Flow Architecture - Message Handling","doc":"```\n┌────────────┐      ┌────────────┐      ┌────────────┐\n│            │      │            │      │            │\n│   Client   │<─────│  Transport │<─────│   Server   │\n│            │─────>│            │─────>│            │\n└────────────┘      └────────────┘      └────────────┘\n```\n\n1. The client sends requests and notifications to the transport layer\n2. The transport delivers these messages to the server\n3. The server processes messages and sends responses or notifications\n4. The transport delivers these back to the client\n5. The client correlates responses with their original requests","ref":"message_handling.html#message-flow-architecture"},{"type":"extras","title":"Request/Response Correlation - Message Handling","doc":"Hermes automatically handles correlation between requests and responses using unique message IDs:\n\n```elixir\n# Inside Hermes.Client implementation\ndefp generate_request_id do\n  binary = < >\n\n  Base.url_encode64(binary)\nend\n```\n\nEach request is assigned a unique ID, and the client maintains a map of pending requests:\n\n```elixir\n# Simplified example of internal state\n%{\n  pending_requests: %{\n    \"request_id_123\" => {from, \"method_name\"},\n    \"request_id_456\" => {from, \"other_method\"}\n  }\n}\n```\n\nWhen a response arrives, it's matched to the original request and forwarded to the waiting process.","ref":"message_handling.html#request-response-correlation"},{"type":"extras","title":"Timeouts and Recovery - Message Handling","doc":"Hermes implements automatic timeout handling for requests:\n\n```elixir\n# Default timeout in milliseconds\n@default_timeout :timer.seconds(30)\n```\n\nIf a response isn't received within the timeout period, the client will:\n\n1. Remove the request from the pending requests map\n2. Send a cancellation notification to the server\n3. Return an error to the caller","ref":"message_handling.html#timeouts-and-recovery"},{"type":"extras","title":"Notification Handling - Message Handling","doc":"Notifications are one-way messages that don't expect a response. Hermes provides a simple API for sending notifications:\n\n```elixir\n# Internal implementation\ndefp send_notification(state, method, params \\\\ %{}) do\n  with {:ok, notification_data} <- encode_notification(method, params) do\n    send_to_transport(state.transport, notification_data)\n  end\nend\n```\n\nThe client sends the `notifications/initialized` notification after successful initialization.","ref":"message_handling.html#notification-handling"},{"type":"extras","title":"Protocol Message Encoding/Decoding - Message Handling","doc":"Hermes uses a structured approach to encode and validate protocol messages.\n\nThe `Hermes.Message` module provides robust validation of all messages against the MCP schema","ref":"message_handling.html#protocol-message-encoding-decoding"},{"type":"extras","title":"Error Handling Patterns - Message Handling","doc":"Hermes implements standardized error handling for all message types:","ref":"message_handling.html#error-handling-patterns"},{"type":"extras","title":"Protocol Errors - Message Handling","doc":"JSON-RPC protocol errors follow the standard error codes:\n\n```elixir\n# Example of handling an error response\ndefp handle_error(%{\"error\" => error, \"id\" => id}, id, state) do\n  {{from, _method}, pending} = Map.pop(state.pending_requests, id)\n\n  # Unblocks original caller\n  GenServer.reply(from, {:error, error})\n\n  %{state | pending_requests: pending}\nend\n```","ref":"message_handling.html#protocol-errors"},{"type":"extras","title":"Transport Errors - Message Handling","doc":"Transport-level errors are wrapped in a standardized format:\n\n```elixir\n# Example of handling a transport error\ndefp send_to_transport(transport, data) do\n  with {:error, reason} <- transport.send_message(data) do\n    {:error, {:transport_error, reason}}\n  end\nend\n```","ref":"message_handling.html#transport-errors"},{"type":"extras","title":"Application Errors - Message Handling","doc":"Application-level errors (e.g., in tool execution) are handled within the result structure:\n\n```elixir\n# Example result for a tool execution error\n{:error, %{\n  \"content\" => [%{\"type\" => \"text\", \"text\" => \"Error message\"}],\n  \"isError\" => true\n}}\n```","ref":"message_handling.html#application-errors"},{"type":"extras","title":"Rate Limiting Considerations - Message Handling","doc":"While Hermes does not impose rate limits directly, implementers should consider:\n\n1. Batching requests when appropriate\n2. Implementing backoff mechanisms for retries\n3. Monitoring request volumes in production","ref":"message_handling.html#rate-limiting-considerations"},{"type":"extras","title":"Progress Tracking","doc":"# Progress Tracking\n\nHermes MCP supports progress notifications for long-running operations as specified in the MCP protocol.","ref":"progress_tracking.html"},{"type":"extras","title":"Overview - Progress Tracking","doc":"The MCP specification includes a progress notification mechanism that allows communicating the progress of long-running operations. Progress updates are useful for:\n\n- Providing feedback for long-running server operations\n- Updating users about the status of operations that might take time to complete\n- Enabling client applications to display progress indicators for better UX","ref":"progress_tracking.html#overview"},{"type":"extras","title":"Progress Tokens - Progress Tracking","doc":"Progress is tracked using tokens that uniquely identify a specific operation. Hermes provides a helper function to generate unique tokens:\n\n```elixir\n# Generate a unique progress token\nprogress_token = Hermes.Message.generate_progress_token()\n```","ref":"progress_tracking.html#progress-tokens"},{"type":"extras","title":"Making Requests with Progress Tracking - Progress Tracking","doc":"Any request can include a progress token to indicate you want to track progress:\n\n```elixir\n# Make a request with progress tracking\nHermes.Client.read_resource(client, \"resource-uri\", \n  progress: [token: progress_token]\n)\n```","ref":"progress_tracking.html#making-requests-with-progress-tracking"},{"type":"extras","title":"Receiving Progress Updates - Progress Tracking","doc":"","ref":"progress_tracking.html#receiving-progress-updates"},{"type":"extras","title":"Method 1: Register a Callback Function - Progress Tracking","doc":"Before making the request, register a callback function to be called when progress notifications arrive:\n\n```elixir\n# Register a callback for a specific progress token\nHermes.Client.register_progress_callback(client, progress_token, \n  fn token, progress, total ->\n    percentage = if total, do: progress / total * 100, else: nil\n    IO.puts(\"Operation #{token} progress: #{progress}/#{total || \"unknown\"} (#{percentage || \"unknown\"}%)\")\n  end\n)\n```","ref":"progress_tracking.html#method-1-register-a-callback-function"},{"type":"extras","title":"Method 2: Provide a Callback with the Request - Progress Tracking","doc":"You can combine the token and callback in a single request:\n\n```elixir\n# Combined approach: request with progress token and callback\nHermes.Client.list_tools(client, \n  progress: [\n    token: progress_token,\n    callback: fn token, progress, total ->\n      # Handle progress updates\n      IO.puts(\"Progress: #{progress}/#{total || \"unknown\"}\")\n    end\n  ]\n)\n```","ref":"progress_tracking.html#method-2-provide-a-callback-with-the-request"},{"type":"extras","title":"Sending Progress Updates (Server Implementation) - Progress Tracking","doc":"When implementing server-side functionality, you can send progress updates to clients:\n\n```elixir\n# Send a progress update to clients\nHermes.Client.send_progress(client, progress_token, 50, 100)\n```","ref":"progress_tracking.html#sending-progress-updates-server-implementation"},{"type":"extras","title":"Cleanup - Progress Tracking","doc":"To avoid memory leaks, unregister callbacks when you're no longer interested in progress updates:\n\n```elixir\n# Unregister a progress callback\nHermes.Client.unregister_progress_callback(client, progress_token)\n```","ref":"progress_tracking.html#cleanup"},{"type":"extras","title":"Complete Example - Progress Tracking","doc":"```elixir\ndefmodule MyApp.LongRunningOperation do\n  def execute_with_progress(client) do\n    # Generate a unique token\n    progress_token = Hermes.Message.generate_progress_token()\n    \n    # Register a callback to handle progress updates\n    Hermes.Client.register_progress_callback(client, progress_token, fn _token, progress, total ->\n      if total do\n        percentage = Float.round(progress / total * 100, 1)\n        IO.puts(\"Progress: #{progress}/#{total} (#{percentage}%)\")\n      else\n        IO.puts(\"Progress: #{progress}/unknown\")\n      end\n    end)\n    \n    # Make the request with the progress token\n    result = Hermes.Client.call_tool(client, \"long-running-operation\", %{}, \n      progress: [token: progress_token]\n    )\n    \n    # Cleanup by unregistering the callback\n    Hermes.Client.unregister_progress_callback(client, progress_token)\n    \n    # Return the result\n    result\n  end\nend\n```","ref":"progress_tracking.html#complete-example"},{"type":"extras","title":"Using Progress within Phoenix LiveView - Progress Tracking","doc":"Progress tracking is particularly useful in interactive web applications:\n\n```elixir\ndefmodule MyAppWeb.ProcessLive do\n  use Phoenix.LiveView\n  \n  def mount(_params, _session, socket) do\n    {:ok, assign(socket, progress: 0, total: 100, running: false)}\n  end\n  \n  def handle_event(\"start_process\", _params, socket) do\n    token = Hermes.Message.generate_progress_token()\n    \n    # Register progress callback\n    Hermes.Client.register_progress_callback(MyApp.Client, token, fn _token, progress, total ->\n      send(self(), {:progress_update, progress, total})\n    end)\n    \n    # Start the operation asynchronously\n    Task.start(fn ->\n      result = Hermes.Client.call_tool(MyApp.Client, \"long-running-operation\", %{},\n        progress: [token: token]\n      )\n      Hermes.Client.unregister_progress_callback(MyApp.Client, token)\n      send(self(), {:operation_complete, result})\n    end)\n    \n    {:noreply, assign(socket, running: true)}\n  end\n  \n  def handle_info({:progress_update, progress, total}, socket) do\n    {:noreply, assign(socket, progress: progress, total: total || 100)}\n  end\n  \n  def handle_info({:operation_complete, result}, socket) do\n    {:noreply, assign(socket, running: false, result: result)}\n  end\n  \n  def render(assigns) do\n    ~H\"\"\"\n     \n       Start Process \n      \n       \n          \n         <%= @progress %>/<%= @total %> \n       \n      \n       \n         Result: \n         <%= inspect(@result) %> \n       \n     \n    \"\"\"\n  end\nend\n```\n\nThis feature enables applications to provide rich, interactive feedback during long-running operations, enhancing the user experience.","ref":"progress_tracking.html#using-progress-within-phoenix-liveview"},{"type":"extras","title":"Logging","doc":"# Logging\n\nHermes MCP supports server-to-client logging as specified in the MCP protocol. This allows servers to send structured log messages to clients for debugging and operational visibility.","ref":"logging.html"},{"type":"extras","title":"Overview - Logging","doc":"The logging mechanism follows the standard syslog severity levels and provides a way for servers to emit structured log messages. Clients can control the verbosity by setting minimum log levels, and register callbacks to handle log messages for custom processing.","ref":"logging.html#overview"},{"type":"extras","title":"Setting Log Level - Logging","doc":"Clients can specify the minimum log level they want to receive from servers:\n\n```elixir\n# Configure the client to receive logs at \"info\" level or higher\n{:ok, _} = Hermes.Client.set_log_level(client, \"info\")\n```\n\nAvailable log levels, in order of increasing severity:\n- `\"debug\"` - Detailed information for debugging\n- `\"info\"` - General information messages\n- `\"notice\"` - Normal but significant events\n- `\"warning\"` - Warning conditions\n- `\"error\"` - Error conditions\n- `\"critical\"` - Critical conditions\n- `\"alert\"` - Action must be taken immediately\n- `\"emergency\"` - System is unusable\n\nSetting a level will result in receiving all messages at that level and above (more severe).","ref":"logging.html#setting-log-level"},{"type":"extras","title":"Receiving Log Messages - Logging","doc":"","ref":"logging.html#receiving-log-messages"},{"type":"extras","title":"Registering Callbacks - Logging","doc":"You can register a callback function to process log messages as they are received:\n\n```elixir\n# Register a callback to handle incoming log messages\nHermes.Client.register_log_callback(client, fn level, data, logger ->\n  IO.puts(\"[#{level}] #{if logger, do: \"[#{logger}] \", else: \"\"}#{inspect(data)}\")\nend)\n```\n\nThe callback function receives:\n- `level` - The log level (debug, info, notice, etc.)\n- `data` - The log data (any JSON-serializable value)\n- `logger` - Optional string identifying the logger source","ref":"logging.html#registering-callbacks"},{"type":"extras","title":"Unregistering Callbacks - Logging","doc":"When you no longer need to process log messages, unregister the callback:\n\n```elixir\n# Unregister a previously registered callback\nHermes.Client.unregister_log_callback(client, callback_function)\n```","ref":"logging.html#unregistering-callbacks"},{"type":"extras","title":"Integrating with Elixir's Logger - Logging","doc":"By default, Hermes MCP automatically logs received messages to Elixir's Logger system, mapping MCP log levels to their Elixir equivalents:\n\n- `\"debug\"` → `Logger.debug/1`\n- `\"info\"`, `\"notice\"` → `Logger.info/1`\n- `\"warning\"` → `Logger.warning/1`\n- `\"error\"`, `\"critical\"`, `\"alert\"`, `\"emergency\"` → `Logger.error/1`\n\nThis provides seamless integration with your existing logging setup.","ref":"logging.html#integrating-with-elixir-s-logger"},{"type":"extras","title":"Example Use Case: LiveView Integration - Logging","doc":"Here's an example of using logging in a Phoenix LiveView application:\n\n```elixir\ndefmodule MyAppWeb.LogsLive do\n  use Phoenix.LiveView\n  \n  def mount(_params, _session, socket) do\n    if connected?(socket) do\n      # Register a callback to handle log messages\n      Hermes.Client.register_log_callback(MyApp.Client, &handle_log/3)\n    end\n    \n    # Set a higher log level initially\n    Hermes.Client.set_log_level(MyApp.Client, \"info\")\n    \n    {:ok, assign(socket, logs: [], log_level: \"info\")}\n  end\n  \n  def handle_event(\"set_log_level\", %{\"level\" => level}, socket) do\n    # Change the logging level based on user selection\n    Hermes.Client.set_log_level(MyApp.Client, level)\n    \n    {:noreply, assign(socket, log_level: level)}\n  end\n  \n  # Callback for log messages\n  defp handle_log(level, data, logger) do\n    send(self(), {:new_log, level, data, logger, DateTime.utc_now()})\n  end\n  \n  def handle_info({:new_log, level, data, logger, timestamp}, socket) do\n    log_entry = %{\n      level: level,\n      data: data,\n      logger: logger,\n      timestamp: timestamp\n    }\n    \n    # Keep the most recent 100 logs\n    logs = [log_entry | socket.assigns.logs] |> Enum.take(100)\n    \n    {:noreply, assign(socket, logs: logs)}\n  end\n  \n  def render(assigns) do\n    ~H\"\"\"\n     \n       \n         \n           Log Level: \n           \n             Debug \n             Info \n             Warning \n             Error \n             Critical \n           \n         \n       \n      \n       \n         \n           \n             \n               Time \n               Level \n               Source \n               Message \n             \n           \n           \n            <%= for log <- @logs do %>\n               \n                 <%= Calendar.strftime(log.timestamp, \"%H:%M:%S\") %> \n                 <%= log.level %> \n                 <%= log.logger || \"-\" %> \n                 <%= inspect(log.data) %> \n               \n            <% end %>\n           \n         \n       \n     \n    \"\"\"\n  end\n  \n  def terminate(_reason, _socket) do\n    # Clean up by unregistering the callback\n    Hermes.Client.unregister_log_callback(MyApp.Client, &handle_log/3)\n    :ok\n  end\nend\n```\n\nThis example demonstrates:\n1. Setting an initial log level\n2. Allowing users to change the log level\n3. Receiving and displaying logs in real-time\n4. Properly cleaning up when the LiveView terminates","ref":"logging.html#example-use-case-liveview-integration"},{"type":"extras","title":"Server-side Recommendations - Logging","doc":"For developers implementing MCP servers, the MCP specification recommends:\n\n1. **Rate limiting** - Limit the volume of log messages to avoid overwhelming clients\n2. **Structured context** - Include relevant context in the data field\n3. **Consistent naming** - Use consistent logger names for categorization\n4. **Sensitive information** - Never include credentials, PII, or security-sensitive information in logs","ref":"logging.html#server-side-recommendations"},{"type":"extras","title":"Security Considerations - Logging","doc":"When implementing MCP clients and servers, be careful about logging sensitive information. The MCP specification explicitly recommends against including credentials, PII, or sensitive system details in log messages.","ref":"logging.html#security-considerations"},{"type":"extras","title":"Error Handling","doc":"# Error Handling\n\nThis guide explains how errors are handled in the Hermes MCP client.","ref":"error_handling.html"},{"type":"extras","title":"Error Types - Error Handling","doc":"Hermes MCP distinguishes between three types of errors:\n\n1. **Protocol errors** (JSON-RPC errors): Standard errors defined by the JSON-RPC 2.0 specification\n2. **Domain errors**: Application-level errors reported by the server with `isError: true`\n3. **Client-side errors**: Errors generated by the client before reaching the server","ref":"error_handling.html#error-types"},{"type":"extras","title":"Error Representation - Error Handling","doc":"Protocol and client-side errors in Hermes MCP are represented as `{:error, %Hermes.MCP.Error{}}` tuples, where `Error` is a struct with:\n\n- `code`: The numeric error code\n- `reason`: The atom reason (e.g., `:parse_error`, `:method_not_found`)\n- `data`: Additional error context\n\nDomain errors (with `isError: true`) are returned as `{:ok, %Hermes.MCP.Response{}}` tuples, where the response includes:\n\n- `result`: The original result from the server (including the `isError` field)\n- `id`: The request ID\n- `is_error`: A boolean flag indicating if this is a domain error","ref":"error_handling.html#error-representation"},{"type":"extras","title":"Protocol Errors - Error Handling","doc":"Protocol errors (JSON-RPC errors) use the standard JSON-RPC error codes with specific reason atoms:\n\n```elixir\n{:error, %Hermes.MCP.Error{\n  code: -32601,\n  reason: :method_not_found,\n  data: %{original_message: \"Method not found\"}\n}}\n```\n\nStandard JSON-RPC error codes:\n- `-32700`: Parse error (`:parse_error`)\n- `-32600`: Invalid request (`:invalid_request`)\n- `-32601`: Method not found (`:method_not_found`)\n- `-32602`: Invalid params (`:invalid_params`)\n- `-32603`: Internal error (`:internal_error`)\n- `-32000`: Server error (`:server_error`)","ref":"error_handling.html#protocol-errors"},{"type":"extras","title":"Domain Errors - Error Handling","doc":"Domain errors (application-level errors) are valid JSON-RPC responses with `isError: true` and are represented as:\n\n```elixir\n{:ok, %Hermes.MCP.Response{\n  result: %{\n    \"isError\" => true,\n    \"reason\" => \"tool_not_found\",\n    \"message\" => \"Tool 'unknown' not found\",\n    \"details\" => %{\"toolName\" => \"unknown\"}\n  },\n  id: \"req_123\",\n  is_error: true\n}}\n```","ref":"error_handling.html#domain-errors"},{"type":"extras","title":"Client-Side Errors - Error Handling","doc":"Client-specific errors follow the same error struct pattern with appropriate reason atoms:\n\n```elixir\n# Transport error\n{:error, %Hermes.MCP.Error{\n  code: -32000,\n  reason: :connection_refused,  \n  data: %{type: :transport}\n}}\n\n# Capability error\n{:error, %Hermes.MCP.Error{\n  code: -32601,\n  reason: :method_not_found,\n  data: %{method: \"resources/list\"}\n}}\n\n# Timeout error\n{:error, %Hermes.MCP.Error{\n  code: -32000, \n  reason: :request_timeout, \n  data: %{type: :client, message: \"Request timed out after 30000ms\"}\n}}\n```","ref":"error_handling.html#client-side-errors"},{"type":"extras","title":"Handling Errors - Error Handling","doc":"The client automatically categorizes errors, returning them in consistent formats.\n\nYou can pattern match on the response structure to handle different error types:\n\n```elixir\ncase Hermes.Client.call_tool(\"search\", %{query: \"example\"}) do\n  {:ok, %Hermes.MCP.Response{is_error: false, result: result}} ->\n    # Handle success\n    handle_success(result)\n    \n  {:ok, %Hermes.MCP.Response{is_error: true, result: result}} ->\n    # Handle domain/application error\n    case result do\n      %{\"reason\" => \"not_found\"} -> \n        Logger.warning(\"Resource not found: #{result[\"message\"]}\")\n      \n      %{\"reason\" => \"permission_denied\"} ->\n        Logger.error(\"Permission denied: #{result[\"message\"]}\")\n        \n      _ ->\n        Logger.error(\"Other domain error: #{inspect(result)}\")\n    end\n    \n  {:error, %Hermes.MCP.Error{reason: :method_not_found}} ->\n    # Handle unsupported method\n    Logger.warning(\"Method not supported by this server\")\n    \n  {:error, %Hermes.MCP.Error{reason: reason}} when reason in [:connection_refused, :timeout] ->\n    # Handle transport errors\n    Logger.error(\"Transport error: #{reason}\")\n    \n  {:error, %Hermes.MCP.Error{} = error} ->\n    # Handle any other error\n    Logger.error(\"Unexpected error: #{inspect(error)}\")\nend\n```","ref":"error_handling.html#handling-errors"},{"type":"extras","title":"Error Inspection - Error Handling","doc":"For better debugging, errors implement a custom Inspect protocol:\n\n```\n#MCP.Error \n```","ref":"error_handling.html#error-inspection"},{"type":"extras","title":"Creating Custom Errors - Error Handling","doc":"If you need to create your own errors in your application:\n\n```elixir\n# Protocol errors\nHermes.MCP.Error.parse_error()\nHermes.MCP.Error.method_not_found(%{method: \"unknown_method\"})\n\n# Transport errors\nHermes.MCP.Error.transport_error(:connection_refused)\n\n# Client errors\nHermes.MCP.Error.client_error(:request_timeout, %{elapsed_ms: 30000})\n```","ref":"error_handling.html#creating-custom-errors"},{"type":"extras","title":"Security Considerations","doc":"# Security Considerations\n\nThis guide covers security best practices and implementation strategies for authentication and authorization with Hermes MCP.","ref":"security.html"},{"type":"extras","title":"MCP Security Overview - Security Considerations","doc":"The Model Context Protocol itself does not define specific authentication or authorization mechanisms. However, securing your MCP connections is essential, particularly when:\n\n1. Exposing MCP services over a network\n2. Handling sensitive data or operations\n3. Integrating with LLMs that have access to tools\n4. Operating in multi-user environments","ref":"security.html#mcp-security-overview"},{"type":"extras","title":"Transport Security - Security Considerations","doc":"","ref":"security.html#transport-security"},{"type":"extras","title":"STDIO Transport Security - Security Considerations","doc":"When using the STDIO transport for local processes:\n\n1. **Process Isolation**: Ensure the spawned process runs with appropriate permissions\n2. **Environment Variables**: Securely manage sensitive environment variables\n3. **Working Directory**: Set appropriate working directory permissions\n4. **Command Validation**: Validate the command and arguments before execution\n\nExample of secure STDIO transport configuration:\n\n```elixir\n# Secure STDIO transport configuration\n{Hermes.Transport.STDIO, [\n  name: MyApp.MCPTransport,\n  client: MyApp.MCPClient,\n  command: \"mcp\", # full path validation internally\n  args: [\"run\", path], # Validate path\n  env: %{\"SECRET_KEY\" => System.fetch_env!(\"MCP_SECRET_KEY\")},\n  cwd: Application.app_dir(:my_app, \"priv/mcp_server\")\n]}\n```","ref":"security.html#stdio-transport-security"},{"type":"extras","title":"HTTP/SSE Transport Security (Planned) - Security Considerations","doc":"For HTTP/SSE transports (planned for future releases):\n\n1. **TLS/SSL**: Always use HTTPS with proper certificate validation\n2. **CORS**: Configure appropriate Cross-Origin Resource Sharing policies\n3. **Rate Limiting**: Implement rate limiting to prevent abuse\n4. **Request Validation**: Validate all incoming requests\n\nExample of future HTTP transport configuration:\n\n```elixir\n# Future HTTP transport configuration\n{Hermes.Transport.HTTP, [\n  name: MyApp.HTTPTransport,\n  client: MyApp.MCPClient,\n  server: [base_url: \"https://example.com\", base_path: \"/mcp\"],\n  headers: [{\"Authorization\", \"Bearer #{token}\"}],\n  transport_opts: [\n    verify: :verify_peer,\n    cacertfile: CAStore.file_path(),\n    depth: 3,\n    verify_fun: :public_key.pkix_verify_hostname_match_fun(:https)\n  ]\n]}\n```","ref":"security.html#http-sse-transport-security-planned"},{"type":"extras","title":"Authentication Implementation Strategies - Security Considerations","doc":"While Hermes MCP doesn't include built-in authentication, here are several approaches to implement your own:","ref":"security.html#authentication-implementation-strategies"},{"type":"extras","title":"1. Transport-Level Authentication - Security Considerations","doc":"Add authentication at the transport level by including credentials in the transport configuration:\n\n```elixir\n# Example with future HTTP transport\n{Hermes.Transport.HTTP, [\n  # ... other options\n  headers: [\n    {\"Authorization\", \"Bearer #{token}\"},\n    {\"X-API-Key\", api_key}\n  ]\n]}\n```","ref":"security.html#1-transport-level-authentication"},{"type":"extras","title":"2. Initialization Authentication - Security Considerations","doc":"Extend the client capabilities to include authentication information during initialization:\n\n```elixir\n# Add authentication data to client initialization\nclient_capabilities = %{\n  \"resources\" => %{},\n  \"tools\" => %{},\n  \"experimental\" => %{\n    \"auth\" => %{\n      \"type\" => \"bearer\",\n      \"token\" => System.fetch_env!(\"MCP_AUTH_TOKEN\")\n    }\n  }\n}\n\n{Hermes.Client, [\n  # ... other options\n  capabilities: client_capabilities\n]}\n```\n\nThe server would then validate these credentials during the initialization handshake.","ref":"security.html#2-initialization-authentication"},{"type":"extras","title":"3. Custom Middleware Authentication - Security Considerations","doc":"Implement a custom authentication middleware that wraps the transport:\n\n```elixir\ndefmodule MyApp.Transport.AuthMiddleware do\n  @behaviour Hermes.Transport.Behaviour\n  \n  defstruct [:inner_transport, :auth_token]\n  \n  def new(inner_transport, auth_token) do\n    %__MODULE__{\n      inner_transport: inner_transport,\n      auth_token: auth_token\n    }\n  end\n  \n  @impl true\n  def start_link(opts) do\n    inner_transport = opts[:inner_transport]\n    auth_token = opts[:auth_token]\n    \n    with {:ok, transport} <- inner_transport.start_link(opts) do\n      {:ok, new(transport, auth_token)}\n    end\n  end\n  \n  @impl true\n  def send_message(%__MODULE__{} = transport, message) do\n    # Add authentication to outgoing JSON-RPC messages\n    case Jason.decode(message) do\n      {:ok, decoded} ->\n        authenticated = add_auth_meta(decoded, transport.auth_token)\n        case Jason.encode(authenticated) do\n          {:ok, json} -> transport.inner_transport.send_message(json)\n          error -> error\n        end\n      \n      error -> error\n    end\n  end\n  \n  defp add_auth_meta(%{\"method\" => _} = request, token) do\n    # Add auth metadata to the request\n    meta = %{\"_meta\" => %{\"auth\" => %{\"token\" => token}}}\n    request\n    |> Map.update(\"params\", meta, fn params -> Map.merge(params, meta) end)\n  end\n  \n  defp add_auth_meta(message, _token), do: message\nend\n```","ref":"security.html#3-custom-middleware-authentication"},{"type":"extras","title":"Authorization Implementation Strategies - Security Considerations","doc":"Authorization determines what operations a client can perform. Here are approaches to implement authorization:","ref":"security.html#authorization-implementation-strategies"},{"type":"extras","title":"1. Resource URI Validation - Security Considerations","doc":"Validate resource URIs against allowed patterns:\n\n```elixir\ndefmodule MyApp.ResourceValidator do\n  def validate_access(uri, user) do\n    case URI.parse(uri) do\n      %URI{scheme: \"file\"} = parsed ->\n        validate_file_access(parsed.path, user)\n        \n      %URI{scheme: \"db\"} ->\n        validate_db_access(uri, user)\n        \n      _ ->\n        {:error, :invalid_uri_scheme}\n    end\n  end\n  \n  defp validate_file_access(path, user) do\n    allowed_paths = user.allowed_paths\n    \n    if Enum.any?(allowed_paths, &String.starts_with?(path, &1)) do\n      :ok\n    else\n      {:error, :unauthorized_path}\n    end\n  end\n  \n  defp validate_db_access(uri, user) do\n    # Database-specific validation\n    # ...\n  end\nend\n```","ref":"security.html#1-resource-uri-validation"},{"type":"extras","title":"2. Tool Permission Management - Security Considerations","doc":"Implement permission checks for tool execution:\n\n```elixir\ndefmodule MyApp.ToolAuthorizer do\n  def authorize(tool_name, arguments, user) do\n    tool_permissions = user.tool_permissions || %{}\n    \n    case Map.get(tool_permissions, tool_name) do\n      nil ->\n        {:error, :tool_not_authorized}\n        \n      permissions ->\n        validate_arguments(tool_name, arguments, permissions)\n    end\n  end\n  \n  defp validate_arguments(\"file_write\", %{\"path\" => path}, permissions) do\n    allowed_paths = permissions.allowed_write_paths || []\n    \n    if Enum.any?(allowed_paths, &String.starts_with?(path, &1)) do\n      :ok\n    else\n      {:error, :path_not_authorized}\n    end\n  end\n  \n  # Additional validation rules for other tools\nend\n```","ref":"security.html#2-tool-permission-management"},{"type":"extras","title":"3. Capability-Based Security - Security Considerations","doc":"Implement capability-based security by only exposing specific capabilities to each client:\n\n```elixir\n# Create custom capabilities based on user permissions\ndefmodule MyApp.CapabilityGenerator do\n  def generate_for_user(user) do\n    %{\n      \"resources\" => generate_resource_capabilities(user),\n      \"tools\" => generate_tool_capabilities(user)\n    }\n  end\n  \n  defp generate_resource_capabilities(user) do\n    if user.can_access_resources do\n      %{\"subscribe\" => user.can_subscribe_resources}\n    else\n      nil\n    end\n  end\n  \n  defp generate_tool_capabilities(user) do\n    if length(user.allowed_tools) > 0 do\n      %{}\n    else\n      nil\n    end\n  end\nend\n```\n\nThen use these capabilities when initializing the client:\n\n```elixir\nuser = MyApp.Accounts.get_user!(user_id)\ncapabilities = MyApp.CapabilityGenerator.generate_for_user(user)\n\n{Hermes.Client, [\n  # ... other options\n  capabilities: capabilities\n]}\n```","ref":"security.html#3-capability-based-security"},{"type":"extras","title":"Best Practices for Secure MCP Implementation - Security Considerations","doc":"1. **Principle of Least Privilege**: Only grant the minimum necessary permissions\n2. **Input Validation**: Validate all user inputs, especially resource URIs and tool arguments\n3. **Audit Logging**: Log all MCP operations for security monitoring and compliance\n4. **Rate Limiting**: Implement rate limiting to prevent abuse\n5. **Secure Defaults**: Use secure defaults and require explicit opt-in for sensitive operations","ref":"security.html#best-practices-for-secure-mcp-implementation"},{"type":"extras","title":"Security with LLM Integration - Security Considerations","doc":"When integrating MCP with Language Models, additional considerations apply:\n\n1. **Tool Sandboxing**: Sandbox tool execution to prevent unintended consequences\n2. **Prompt Isolation**: Ensure prompts cannot access unauthorized information\n3. **User Confirmation**: Require user confirmation for sensitive operations\n4. **Context Boundaries**: Maintain strict boundaries between different LLM conversations\n5. **Output Filtering**: Filter LLM outputs to prevent sensitive data leakage","ref":"security.html#security-with-llm-integration"},{"type":"extras","title":"Troubleshooting","doc":"# Troubleshooting\n\nThis guide provides solutions for common issues encountered when working with Hermes MCP.","ref":"troubleshooting.html"},{"type":"extras","title":"Connection Issues - Troubleshooting","doc":"","ref":"troubleshooting.html#connection-issues"},{"type":"extras","title":"Client Cannot Connect to Server - Troubleshooting","doc":"**Symptoms:**\n- Client initialization fails\n- Timeouts during initialization\n- Transport errors\n\n**Potential Causes and Solutions:**\n\n1. **Server Not Running**\n   - Verify the server process is running\n   - Check process exit codes and logs\n   - Ensure the command path is correct\n\n   ```elixir\n   # Verify command can be found\n   if cmd = System.find_executable(\"mcp\") do\n     IO.puts(\"Found MCP at: #{cmd}\")\n   else\n     IO.puts(\"MCP command not found in PATH\")\n   end\n   ```\n\n2. **Transport Configuration**\n   - Double-check transport configuration parameters\n   - Verify working directory permissions\n   - Check for environment variable issues\n\n   ```elixir\n   # Test transport manually\n   {:ok, transport} = Hermes.Transport.STDIO.start_link(\n     client: self(),\n     command: \"mcp\",\n     args: [\"--version\"]\n   )\n   \n   # Should output version information\n   ```\n\n3. **Port Issues**\n   - Check for port conflicts in HTTP/SSE transport\n   - Verify firewall settings if connecting remotely\n   - Check timeout settings in your client configuration","ref":"troubleshooting.html#client-cannot-connect-to-server"},{"type":"extras","title":"Protocol Errors - Troubleshooting","doc":"","ref":"troubleshooting.html#protocol-errors"},{"type":"extras","title":"Version Negotiation Failures - Troubleshooting","doc":"**Symptoms:**\n- Error like \"Unsupported protocol version\"\n- Initialization fails after transport connects\n\n**Solutions:**\n- Verify both client and server support compatible protocol versions\n- Check the server logs for supported versions\n- Update your Hermes MCP client to a compatible version\n\n```elixir\n# Log initialization error for debugging\n# In your error handler\nLogger.error(\"Protocol version error: #{inspect(error)}\")\n```","ref":"troubleshooting.html#version-negotiation-failures"},{"type":"extras","title":"Capability Negotiation Issues - Troubleshooting","doc":"**Symptoms:**\n- Operations fail with errors about missing capabilities\n- Some features don't work as expected\n\n**Solutions:**\n- Check which capabilities are advertised by both client and server\n- Make sure required capabilities are included in your client configuration\n- Inspect server capabilities after initialization\n\n```elixir\n# Debug server capabilities\nserver_capabilities = Hermes.Client.get_server_capabilities(MyApp.MCPClient)\nIO.inspect(server_capabilities, label: \"Server capabilities\")\n```","ref":"troubleshooting.html#capability-negotiation-issues"},{"type":"extras","title":"Message Handling Issues - Troubleshooting","doc":"","ref":"troubleshooting.html#message-handling-issues"},{"type":"extras","title":"Request Timeouts - Troubleshooting","doc":"**Symptoms:**\n- Operations fail with timeout errors\n- Long-running operations consistently fail\n\n**Solutions:**\n- Increase the request timeout for specific operations\n- Check for performance issues on the server\n- Review network latency between client and server\n\n```elixir\n# Use a longer timeout for slow operations\n{:ok, result} = Hermes.Client.call_tool(\n  MyApp.MCPClient,\n  \"slow_operation\",\n  %{},\n  timeout: 120_000  # 2 minutes\n)\n```","ref":"troubleshooting.html#request-timeouts"},{"type":"extras","title":"Message Parsing Errors - Troubleshooting","doc":"**Symptoms:**\n- \"Failed to decode response\" errors\n- \"Invalid message\" errors\n\n**Solutions:**\n- Check for message format issues\n- Verify the server is sending valid JSON-RPC 2.0 messages\n- Enable verbose logging to inspect raw messages\n\n```elixir\n# Set debug logging for Hermes.Message\nLogger.configure(level: :debug)\n```","ref":"troubleshooting.html#message-parsing-errors"},{"type":"extras","title":"Resource-Related Issues - Troubleshooting","doc":"","ref":"troubleshooting.html#resource-related-issues"},{"type":"extras","title":"Resource Not Found - Troubleshooting","doc":"**Symptoms:**\n- `{:error, %{\"code\" => -32002, \"message\" => \"Resource not found\"}}`\n- Resource operations consistently fail\n\n**Solutions:**\n- Verify the resource URI is correct\n- Check if the server has access to the resource\n- List available resources to confirm what's accessible\n\n```elixir\n# List all available resources\n{:ok, %{\"resources\" => resources}} = Hermes.Client.list_resources(MyApp.MCPClient)\nIO.inspect(resources, label: \"Available resources\")\n```","ref":"troubleshooting.html#resource-not-found"},{"type":"extras","title":"Resource Content Issues - Troubleshooting","doc":"**Symptoms:**\n- Resource content is corrupted or truncated\n- Binary resources have encoding issues\n\n**Solutions:**\n- Check for encoding/decoding issues\n- Verify resource size limits\n- Try alternative resource access methods\n\n```elixir\n# Test reading a resource with explicit content type expectations\ncase Hermes.Client.read_resource(MyApp.MCPClient, \"file:///example.txt\") do\n  {:ok, %{\"contents\" => [%{\"text\" => text}]}} ->\n    IO.puts(\"Successfully read text content: #{String.slice(text, 0, 100)}...\")\n    \n  {:ok, %{\"contents\" => [%{\"blob\" => _blob}]}} ->\n    IO.puts(\"Successfully read binary content\")\n    \n  error ->\n    IO.inspect(error, label: \"Error reading resource\")\nend\n```","ref":"troubleshooting.html#resource-content-issues"},{"type":"extras","title":"Tool-Related Issues - Troubleshooting","doc":"","ref":"troubleshooting.html#tool-related-issues"},{"type":"extras","title":"Tool Not Found - Troubleshooting","doc":"**Symptoms:**\n- `{:error, %{\"code\" => -32601, \"message\" => \"Method not found\"}}`\n- Tool calls consistently fail\n\n**Solutions:**\n- Verify the tool name is correct\n- Check if the server has the tool available\n- List available tools to confirm what's accessible\n\n```elixir\n# List all available tools\n{:ok, %{\"tools\" => tools}} = Hermes.Client.list_tools(MyApp.MCPClient)\nIO.inspect(tools, label: \"Available tools\")\n```","ref":"troubleshooting.html#tool-not-found"},{"type":"extras","title":"Tool Execution Errors - Troubleshooting","doc":"**Symptoms:**\n- `{:ok, %{\"content\" => [...], \"isError\" => true}}`\n- Tool returns error responses\n\n**Solutions:**\n- Check tool arguments for correctness\n- Review server logs for detailed error information\n- Test with simplified arguments to isolate the issue\n\n```elixir\n# Step through tool execution with simple arguments\ncase Hermes.Client.call_tool(MyApp.MCPClient, \"problematic_tool\", %{\"simple\" => \"value\"}) do\n  {:ok, %{\"content\" => content, \"isError\" => true}} ->\n    IO.puts(\"Tool execution error:\")\n    Enum.each(content, fn\n      %{\"type\" => \"text\", \"text\" => text} -> IO.puts(\"  #{text}\")\n      _ -> nil\n    end)\n    \n  {:ok, result} ->\n    IO.puts(\"Tool executed successfully\")\n    \n  error ->\n    IO.inspect(error, label: \"Error calling tool\")\nend\n```","ref":"troubleshooting.html#tool-execution-errors"},{"type":"extras","title":"Prompt-Related Issues - Troubleshooting","doc":"","ref":"troubleshooting.html#prompt-related-issues"},{"type":"extras","title":"Prompt Template Errors - Troubleshooting","doc":"**Symptoms:**\n- Prompt retrieval fails with parameter errors\n- Unexpected prompt content\n\n**Solutions:**\n- Verify required arguments are provided\n- Check argument format and types\n- Inspect the prompt template requirements\n\n```elixir\n# List prompt arguments\n{:ok, %{\"prompts\" => prompts}} = Hermes.Client.list_prompts(MyApp.MCPClient)\nprompt = Enum.find(prompts, & &1[\"name\"] == \"target_prompt\")\nIO.inspect(prompt[\"arguments\"], label: \"Required arguments\")\n```","ref":"troubleshooting.html#prompt-template-errors"},{"type":"extras","title":"Supervision and Lifecycle Issues - Troubleshooting","doc":"","ref":"troubleshooting.html#supervision-and-lifecycle-issues"},{"type":"extras","title":"Process Crashes - Troubleshooting","doc":"**Symptoms:**\n- Client or transport processes terminate unexpectedly\n- Supervisor restarts processes frequently\n\n**Solutions:**\n- Review process crash reasons in logs\n- Check for resource leaks or memory issues\n- Consider adjusting supervision strategy\n\n```elixir\n# Check process state\ncase Process.whereis(MyApp.MCPClient) do\n  nil ->\n    IO.puts(\"Client process not running!\")\n    \n  pid ->\n    IO.puts(\"Client is running with PID: #{inspect(pid)}\")\n    Process.info(pid, :message_queue_len)\n    |> IO.inspect(label: \"Message queue length\")\nend\n```","ref":"troubleshooting.html#process-crashes"},{"type":"extras","title":"Memory Usage Issues - Troubleshooting","doc":"**Symptoms:**\n- Growing memory usage\n- Slow performance over time\n\n**Solutions:**\n- Check for message or state accumulation\n- Review resource cleanup procedures\n- Consider implementing periodic restarts for long-running processes","ref":"troubleshooting.html#memory-usage-issues"},{"type":"extras","title":"Debugging Techniques - Troubleshooting","doc":"","ref":"troubleshooting.html#debugging-techniques"},{"type":"extras","title":"Enabling Verbose Logging - Troubleshooting","doc":"Increase logging detail for better diagnostics:\n\n```elixir\n# In your config/dev.exs or at runtime\nLogger.configure(level: :debug)\n```","ref":"troubleshooting.html#enabling-verbose-logging"},{"type":"extras","title":"Inspecting Message Flow - Troubleshooting","doc":"To debug message flow between client and server:\n\n```elixir\n# Create a custom logger transport\ndefmodule MyApp.DebugTransport do\n  @behaviour Hermes.Transport.Behaviour\n  \n  defstruct [:inner_transport]\n  \n  def new(inner_transport) do\n    %__MODULE__{inner_transport: inner_transport}\n  end\n  \n  def start_link(opts) do\n    inner_transport_module = opts[:inner_transport_module]\n    inner_opts = Keyword.delete(opts, :inner_transport_module)\n    \n    with {:ok, transport} <- inner_transport_module.start_link(inner_opts) do\n      {:ok, new(transport)}\n    end\n  end\n  \n  def send_message(%__MODULE__{} = transport, message) do\n    Logger.debug(\">> OUTGOING: #{inspect(message)}\")\n    transport.inner_transport.send_message(message)\n  end\n  \n  def send_message(pid, message) when is_pid(pid) do\n    Logger.debug(\">> OUTGOING: #{inspect(message)}\")\n    transport = :sys.get_state(pid)\n    send_message(transport, message)\n  end\nend\n\n# Then use it in your setup\n{MyApp.DebugTransport, [\n  name: MyApp.DebugMCPTransport,\n  inner_transport_module: Hermes.Transport.STDIO,\n  client: MyApp.MCPClient,\n  command: \"mcp\",\n  args: [\"run\", \"server.py\"]\n]}\n```","ref":"troubleshooting.html#inspecting-message-flow"},{"type":"extras","title":"Testing Connection in Isolation - Troubleshooting","doc":"To test the transport separately:\n\n```elixir\n# In IEx console\niex> {:ok, transport} = Hermes.Transport.STDIO.start_link(\n...>   client: self(),\n...>   command: \"mcp\",\n...>   args: [\"run\", \"echo_server.py\"]\n...> )\niex> transport.send_message(\"{\\\"jsonrpc\\\":\\\"2.0\\\",\\\"method\\\":\\\"ping\\\",\\\"id\\\":1}\\n\")\niex> flush()  # Should see the response\n```","ref":"troubleshooting.html#testing-connection-in-isolation"},{"type":"extras","title":"Performance Considerations - Troubleshooting","doc":"","ref":"troubleshooting.html#performance-considerations"},{"type":"extras","title":"Optimizing Request Handling - Troubleshooting","doc":"For better performance:\n\n1. **Batch Requests When Possible**\n   - Group related operations together\n   - Minimize round-trips for small operations\n\n2. **Consider Resource Size**\n   - Be cautious with large resources\n   - Use pagination for large collections\n\n3. **Connection Management**\n   - Keep long-lived connections when appropriate\n   - Implement connection pooling for multi-user scenarios","ref":"troubleshooting.html#optimizing-request-handling"},{"type":"extras","title":"Getting Additional Help - Troubleshooting","doc":"If you're still experiencing issues:\n\n1. Check the [GitHub Issues](https://github.com/cloudwalk/hermes-mcp/issues) for similar problems\n2. Look for known issues in the [MCP Specification](https://spec.modelcontextprotocol.io/)\n3. Join the Elixir community channels to ask for help","ref":"troubleshooting.html#getting-additional-help"},{"type":"extras","title":"Examples","doc":"# Examples\n\nThis page provides practical examples of using Hermes MCP in different scenarios. Each example demonstrates a specific use case or pattern to help you implement MCP in your Elixir applications.","ref":"examples.html"},{"type":"extras","title":"Basic Client Example - Examples","doc":"This example shows a complete implementation of a simple Hermes MCP client that connects to a Python MCP server.\n\nGiven an Echo Python MCP server:\n\n```python\nfrom mcp.server.fastmcp import FastMCP\n\nmcp = FastMCP(\"Echo\")\n\n@mcp.resource(\"echo://{message}\")\ndef echo_resource(message: str) -> str:\n    \"\"\"Echo a message as a resource\"\"\"\n    return f\"Resource echo: {message}\"\n\n@mcp.tool()\ndef echo_tool(message: str) -> str:\n    \"\"\"Echo a message as a tool\"\"\"\n    return f\"Tool echo: {message}\"\n\n@mcp.prompt()\ndef echo_prompt(message: str) -> str:\n    \"\"\"Create an echo prompt\"\"\"\n    return f\"Please process this message: {message}\"\n\nif __name__ == \"__main__\":\n    mcp.run(transport='stdio')\n```\n\nYou can check the custom Mix.Tasks that `Hermes defines` to run and interactive with this server from Elixir, that are:\n\n- [stdio.echo](https://github.com/cloudwalk/hermes-mcp/blob/main/lib/mix/tasks/stdio.echo.ex)\n- [stdio.echo.interactive](https://github.com/cloudwalk/hermes-mcp/blob/main/lib/mix/tasks/stdio.echo.interactive.ex)","ref":"examples.html#basic-client-example"},{"type":"extras","title":"Authentication Example - Examples","doc":"This example demonstrates a custom authentication middleware for STDIO transport:\n\n```elixir\ndefmodule MyApp.AuthenticatedTransport do\n  @moduledoc \"\"\"\n  A transport middleware that adds authentication to JSON-RPC messages.\n  \"\"\"\n  \n  @behaviour Hermes.Transport.Behaviour\n  \n  alias Hermes.Transport.STDIO\n  \n  defstruct [:inner_transport, :auth_token, :client]\n  \n  @doc \"\"\"\n  Starts a new authenticated transport.","ref":"examples.html#authentication-example"},{"type":"extras","title":"Options - Examples","doc":"* `:inner_transport_module` - The underlying transport module to use (required)\n    * `:auth_token` - The authentication token to use (required)\n    * Other options are passed to the inner transport\n  \"\"\"\n  @impl true\n  def start_link(opts) do\n    client = Keyword.fetch!(opts, :client)\n    auth_token = Keyword.fetch!(opts, :auth_token)\n    inner_transport_module = Keyword.get(opts, :inner_transport_module, STDIO)\n    \n    # Remove our custom options before passing to inner transport\n    inner_opts = opts\n                 |> Keyword.delete(:auth_token)\n                 |> Keyword.delete(:inner_transport_module)\n    \n    with {:ok, transport} <- inner_transport_module.start_link(inner_opts) do\n      state = %__MODULE__{\n        inner_transport: transport,\n        auth_token: auth_token,\n        client: client\n      }\n      \n      pid = spawn_link(fn -> process_loop(state) end)\n      \n      # Register the process name if provided\n      if name = Keyword.get(opts, :name) do\n        Process.register(pid, name)\n      end\n      \n      {:ok, pid}\n    end\n  end\n  \n  @impl true\n  def send_message(pid, message) when is_pid(pid) and is_binary(message) do\n    send(pid, {:send, message})\n    :ok\n  end\n  \n  @impl true\n  def send_message(name, message) when is_atom(name) and is_binary(message) do\n    send(name, {:send, message})\n    :ok\n  end\n  \n  # Main process loop\n  defp process_loop(state) do\n    receive do\n      {:send, message} ->\n        # Add authentication to outgoing messages\n        case Jason.decode(message) do\n          {:ok, decoded} ->\n            authenticated = add_auth(decoded, state.auth_token)\n            \n            case Jason.encode(authenticated) do\n              {:ok, json} ->\n                Hermes.Transport.Behaviour.send_message(state.inner_transport, json <> \"\\n\")\n                \n              {:error, reason} ->\n                error = \"Failed to encode authenticated message: #{inspect(reason)}\"\n                IO.puts(:stderr, error)\n            end\n            \n          {:error, reason} ->\n            error = \"Failed to decode message for authentication: #{inspect(reason)}\"\n            IO.puts(:stderr, error)\n        end\n        \n      {:response, data} ->\n        # Forward responses directly to the client\n        send(state.client, {:response, data})\n        \n      other ->\n        IO.puts(:stderr, \"AuthenticatedTransport received unknown message: #{inspect(other)}\")\n    end\n    \n    process_loop(state)\n  end\n  \n  # Add authentication metadata to requests\n  defp add_auth(%{\"method\" => method, \"params\" => params} = request, token) do\n    # Skip authentication for the initialization message\n    if method == \"initialize\" do\n      request\n    else\n      auth_meta = %{\"_meta\" => %{\"auth\" => %{\"token\" => token}}}\n      \n      # Merge with existing params\n      updated_params = Map.merge(params || %{}, auth_meta)\n      %{request | \"params\" => updated_params}\n    end\n  end\n  \n  # Handle messages without params\n  defp add_auth(%{\"method\" => method} = request, token) do\n    if method == \"initialize\" do\n      request\n    else\n      auth_meta = %{\"_meta\" => %{\"auth\" => %{\"token\" => token}}}\n      Map.put(request, \"params\", auth_meta)\n    end\n  end\n  \n  # Pass through other message types unchanged\n  defp add_auth(message, _token), do: message\nend\n```\n\nUsage example with authenticated transport:\n\n```elixir\n# In your application's supervision tree\nchildren = [\n  # ...\n  \n  # Start the authenticated transport\n  {MyApp.AuthenticatedTransport, [\n    name: MyApp.MCPTransport,\n    client: MyApp.MCPClient,\n    auth_token: System.fetch_env!(\"MCP_AUTH_TOKEN\"),\n    inner_transport_module: Hermes.Transport.STDIO,\n    command: \"mcp\",\n    args: [\"run\", \"server.py\"]\n  ]},\n  \n  # Start the MCP client using the authenticated transport\n  {Hermes.Client, [\n    name: MyApp.MCPClient,\n    transport: MyApp.MCPTransport,\n    client_info: %{\n      \"name\" => \"MyAuthenticatedApp\",\n      \"version\" => \"1.0.0\"\n    },\n    capabilities: %{\n      \"resources\" => %{},\n      \"tools\" => %{},\n      \"prompts\" => %{}\n    }\n  ]},\n  \n  # ...\n]\n```","ref":"examples.html#options"},{"type":"extras","title":"Resource Abstraction Example - Examples","doc":"This example demonstrates a higher-level abstraction over MCP resources:\n\n```elixir\ndefmodule MyApp.Resource do\n  @moduledoc \"\"\"\n  A high-level abstraction for working with MCP resources.\n  \"\"\"\n  \n  alias Hermes.Client\n  \n  @type t :: %__MODULE__{\n    uri: String.t(),\n    name: String.t(),\n    description: String.t() | nil,\n    mime_type: String.t() | nil,\n    size: integer() | nil,\n    client: pid() | atom()\n  }\n  \n  defstruct [:uri, :name, :description, :mime_type, :size, :client]\n  \n  @doc \"\"\"\n  Lists all available resources from the MCP server.\n  \"\"\"\n  @spec list(pid() | atom()) :: {:ok, [t()]} | {:error, term()}\n  def list(client) do\n    case Client.list_resources(client) do\n      {:ok, %{\"resources\" => resources}} ->\n        resources = Enum.map(resources, fn resource ->\n          %__MODULE__{\n            uri: resource[\"uri\"],\n            name: resource[\"name\"],\n            description: resource[\"description\"],\n            mime_type: resource[\"mimeType\"],\n            size: resource[\"size\"],\n            client: client\n          }\n        end)\n        \n        {:ok, resources}\n        \n      error ->\n        error\n    end\n  end\n  \n  @doc \"\"\"\n  Reads the content of a resource.\n  \n  Returns the content as text if possible, otherwise as binary.\n  \"\"\"\n  @spec read(t() | String.t(), pid() | atom()) :: {:ok, String.t() | binary()} | {:error, term()}\n  def read(%__MODULE__{} = resource), do: read(resource.uri, resource.client)\n  def read(uri, client) when is_binary(uri) do\n    case Client.read_resource(client, uri) do\n      {:ok, %{\"contents\" => contents}} ->\n        content = case contents do\n          [%{\"text\" => text} | _] -> {:ok, text}\n          [%{\"blob\" => blob} | _] -> {:ok, blob}\n          [] -> {:error, :empty_content}\n          other -> {:error, {:unexpected_content, other}}\n        end\n        \n        content\n        \n      error ->\n        error\n    end\n  end\n  \n  @doc \"\"\"\n  Creates a resource from a map of resource attributes.\n  \"\"\"\n  @spec from_map(map(), pid() | atom()) :: t()\n  def from_map(map, client) do\n    %__MODULE__{\n      uri: map[\"uri\"],\n      name: map[\"name\"],\n      description: map[\"description\"],\n      mime_type: map[\"mimeType\"],\n      size: map[\"size\"],\n      client: client\n    }\n  end\n  \n  @doc \"\"\"\n  Finds a resource by name.\n  \"\"\"\n  @spec find_by_name(String.t(), pid() | atom()) :: {:ok, t()} | {:error, :not_found} | {:error, term()}\n  def find_by_name(name, client) do\n    with {:ok, resources} <- list(client) do\n      case Enum.find(resources, fn r -> r.name == name end) do\n        nil -> {:error, :not_found}\n        resource -> {:ok, resource}\n      end\n    end\n  end\n  \n  @doc \"\"\"\n  Checks if a resource is text-based or binary.\n  \"\"\"\n  @spec text?(t()) :: boolean()\n  def text?(%__MODULE__{mime_type: mime_type}) when is_binary(mime_type) do\n    String.starts_with?(mime_type, \"text/\") or\n      mime_type in [\"application/json\", \"application/xml\", \"application/javascript\"]\n  end\n  def text?(_), do: false\nend\n```\n\nUsage example:\n\n```elixir\n# List all resources\n{:ok, resources} = MyApp.Resource.list(MyApp.MCPClient)\n\n# Find a specific resource by name\n{:ok, config} = MyApp.Resource.find_by_name(\"config.json\", MyApp.MCPClient)\n\n# Read a resource's content\n{:ok, content} = MyApp.Resource.read(config)\n\nif MyApp.Resource.text?(config) do\n  IO.puts(\"Text content: #{content}\")\nelse\n  IO.puts(\"Binary content: #{byte_size(content)} bytes\")\nend\n```\n\nThese examples demonstrate different approaches to using Hermes MCP in your Elixir applications. You can adapt and extend these patterns to suit your specific needs.","ref":"examples.html#resource-abstraction-example"},{"type":"extras","title":"RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"# RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","ref":"rfc.html"},{"type":"extras","title":"1. Introduction - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"This document defines the design and architecture of an Elixir library that implements both the client and server aspects of the Model Context Protocol (MCP). The goal is to provide a unified solution that supports robust JSON‑RPC 2.0 communication, leverages Elixir's concurrency and fault tolerance, and integrates seamlessly with Phoenix for server operations. The library will expose a high‑level client API that abstracts transport details and a server API that is compliant with Phoenix conventions for building HTTP endpoints. The design is modular, extensible, and structured to support future enhancements.\n\nFor further context on MCP, see the [Anthropic announcement](https://www.anthropic.com/news/model-context-protocol) and the [Glama Quickstart](https://glama.ai/blog/2024-11-25-model-context-protocol-quickstart).\n\n---","ref":"rfc.html#1-introduction"},{"type":"extras","title":"2. Library Architecture Overview - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"","ref":"rfc.html#2-library-architecture-overview"},{"type":"extras","title":"2.1 General Structure - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The library is divided into two main components: the Client and the Server. Both components share core infrastructure for JSON‑RPC handling, configuration, and error management. The Client is designed to provide a high‑level API that abstracts connection management and messaging details, while the Server exposes MCP functionality through Phoenix‑compliant endpoints.\n\nA central configuration module governs the behavior of both components, allowing runtime customization of timeouts, protocol versions, and transport preferences. Middleware hooks are provided at strategic points to support additional processing such as authentication, logging, or transformation.","ref":"rfc.html#2-1-general-structure"},{"type":"extras","title":"2.2 Core Components - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"At the lowest level, a transport abstraction layer decouples the specifics of STDIO, HTTP, or other transports from the core logic. The connection manager (implemented as a GenServer) oversees the client's lifecycle, including the initialization handshake and message correlation. For the server, a dispatcher module routes incoming JSON‑RPC messages (received via a Phoenix controller or Plug) to the appropriate tool handler registered in a tool registry. These components are organized under a comprehensive supervision tree to ensure fault tolerance and automatic recovery.\n\n---","ref":"rfc.html#2-2-core-components"},{"type":"extras","title":"3. Protocol Lifecycle Management - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The Model Context Protocol defines specific lifecycle requirements that both clients and servers must implement. Our Elixir library provides unified lifecycle management that serves both roles through shared infrastructure while maintaining clear separation of concerns.","ref":"rfc.html#3-protocol-lifecycle-management"},{"type":"extras","title":"3.1 Shared Infrastructure - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The library implements the protocol lifecycle through a state machine that governs connection establishment, message exchange, and termination. This shared infrastructure leverages Elixir's GenServer and supervision capabilities to provide robust state management and fault tolerance regardless of whether the library is operating in client or server mode.\n\n```mermaid\nstateDiagram-v2\n    [*] --> Initializing\n    Initializing --> Active: Capability Exchange Complete\n    Active --> Recovering: Connection Issue\n    Recovering --> Initializing: Retry Connection\n    Active --> Terminating: Shutdown Requested\n    Recovering --> Terminating: Recovery Failed\n    Terminating --> [*]\n```","ref":"rfc.html#3-1-shared-infrastructure"},{"type":"extras","title":"3.2 Client Lifecycle - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"When operating as a client, the library actively initiates and manages connections to MCP servers. The client connection manager handles the following responsibilities:\n\nThe client begins by establishing a transport connection and sending an initialization request containing its capabilities and protocol version. Upon receiving the server's capability response, it validates compatibility and transitions to the active state. Throughout the session, it maintains correlation between requests and responses while monitoring connection health.\n\nDuring recovery scenarios, the client connection manager attempts to reestablish the transport connection and reinitialize the protocol session. It provides configurable retry policies and transparent recovery when possible.","ref":"rfc.html#3-2-client-lifecycle"},{"type":"extras","title":"3.3 Server Lifecycle - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"As a server, the library acts as a passive participant in lifecycle management, responding to client initiatives while maintaining session isolation. The server session manager creates dedicated processes for each client connection, ensuring proper resource cleanup on termination.\n\nWhen receiving a client's initialization request, the server validates the protocol version compatibility and responds with its supported capabilities. It then maintains session state for the connection, tracking active subscriptions and managing resource access. The server uses Phoenix's connection management facilities when operating over HTTP/SSE transport.","ref":"rfc.html#3-3-server-lifecycle"},{"type":"extras","title":"3.4 Lifecycle Integration - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The following sequence diagram illustrates how the client and server components interact during a typical protocol lifecycle:\n\n```mermaid\nsequenceDiagram\n    participant Client\n    participant Transport\n    participant Server\n    \n    Note over Client,Server: Transport Establishment\n    Client->>Transport: Connect\n    Transport->>Server: Accept Connection\n    \n    Note over Client,Server: Initialization Phase\n    Client->>Server: Initialize Request (capabilities)\n    Server-->>Client: Initialize Response (capabilities)\n    Client->>Server: Initialized Notification\n    \n    Note over Client,Server: Active Session\n    Client->>Server: Protocol Messages\n    Server-->>Client: Protocol Responses\n    \n    Note over Client,Server: Termination\n    Client->>Server: Close Connection\n    Server-->>Client: Acknowledge Close\n```","ref":"rfc.html#3-4-lifecycle-integration"},{"type":"extras","title":"3.5 Error Management - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The library implements comprehensive error handling for both client and server roles. Errors are categorized into:\n\nProtocol Errors: Version mismatches or capability incompatibilities are handled through standardized error responses that maintain protocol compliance.\n\nTransport Errors: Connection failures trigger appropriate recovery mechanisms based on the component's role. Clients attempt reconnection while servers clean up affected sessions.\n\nApplication Errors: Errors during tool execution or resource access are propagated through the protocol's error reporting mechanisms while maintaining session stability.\n\nThis unified approach to lifecycle management ensures protocol compliance while providing robust operation in both client and server roles. The library's supervision strategies and process isolation enable reliable recovery from failure scenarios while maintaining proper resource cleanup.","ref":"rfc.html#3-5-error-management"},{"type":"extras","title":"4. Engineering Considerations - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"","ref":"rfc.html#4-engineering-considerations"},{"type":"extras","title":"4.1 Client Implementation - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The client's core responsibility is to manage the connection and message exchange with an MCP server. A GenServer will serve as the connection manager, maintaining state (such as pending message IDs and associated callbacks) and handling the initialization handshake. The transport layer will be defined by a set of behaviors, which will allow developers to implement additional transport modules (e.g., STDIO or WebSocket) without modifying the core client logic. Error handling is performed through standardized mappings to Elixir's error tuples, and configurable timeouts are implemented to avoid blocking calls.","ref":"rfc.html#4-1-client-implementation"},{"type":"extras","title":"4.2 Server Implementation - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"For the server, Phoenix integration is a primary design goal. The library will provide a Plug/Phoenix module that acts as the HTTP interface for MCP. Incoming JSON‑RPC messages are first parsed and validated, then dispatched to the correct tool handler as registered in the tool registry. The dispatcher module uses asynchronous Tasks to invoke tool handlers, ensuring that long‑running operations do not delay the overall request-response cycle. Session management is achieved by isolating client interactions within dedicated processes, which allows the server to maintain state and context for each connection independently. Additionally, extensive logging and observability hooks are built in to facilitate debugging and performance monitoring.","ref":"rfc.html#4-2-server-implementation"},{"type":"extras","title":"4.3 Shared and Extensible Architecture - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"Both the client and server components share a common configuration module that reads settings from Elixir's configuration files (e.g., config.exs). Middleware hooks are available for both sides, enabling developers to insert custom authentication, logging, or transformation logic into the processing pipeline. The design adheres to a strict supervision tree structure to automatically recover from process failures and to maintain high availability. This shared architecture not only simplifies maintenance but also ensures that future enhancements can be integrated with minimal disruption.","ref":"rfc.html#4-3-shared-and-extensible-architecture"},{"type":"extras","title":"5. Roadmap for Version 0.1.0 - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The roadmap for version 0.1.0 focuses on delivering a robust and well-tested client interface before expanding to full server functionality.","ref":"rfc.html#5-roadmap-for-version-0-1-0"},{"type":"extras","title":"5.1 Phase 1: Design and Requirements (Weeks 1-2) - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"During this phase, a detailed design document is created based on the MCP specification. This includes defining the minimal set of features for the client, specifying the public API functions (connect/1, request/2, notify/2), and designing the transport abstraction layer. Prototypes for the connection manager are built and validated against simulated MCP server responses.","ref":"rfc.html#5-1-phase-1-design-and-requirements-weeks-1-2"},{"type":"extras","title":"5.2 Phase 2: Core Client Module Implementation (Weeks 3-5) - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"In this phase, the core client module is developed. The connection manager GenServer is implemented, handling the JSON‑RPC handshake and managing state for pending requests. Basic error handling and timeout logic are integrated, and unit tests are written for each component. The transport abstraction is implemented initially for STDIO, with a clear interface for future extensions.","ref":"rfc.html#5-2-phase-2-core-client-module-implementation-weeks-3-5"},{"type":"extras","title":"5.3 Phase 3: Transport Abstraction and High-Level API (Weeks 6-7) - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"The focus shifts to refining the transport abstraction layer, ensuring that it supports multiple transport mechanisms seamlessly. The high‑level client API is finalized to provide idiomatic functions that hide low‑level details. Documentation is updated with usage examples and configuration guidelines.","ref":"rfc.html#5-3-phase-3-transport-abstraction-and-high-level-api-weeks-6-7"},{"type":"extras","title":"5.4 Phase 4: Integration Testing and Documentation (Weeks 8-9) - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"Comprehensive integration tests are performed by simulating connections to a basic test MCP server. Detailed documentation, including API reference guides and example applications, is produced. Performance metrics, logging outputs, and error scenarios are verified to ensure that the client component meets production standards.","ref":"rfc.html#5-4-phase-4-integration-testing-and-documentation-weeks-8-9"},{"type":"extras","title":"5.5 Phase 5: Beta Release and Feedback (Week 10) - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"A beta version of version 0.1.0 is released to early adopters. Feedback is collected regarding usability, stability, and performance. Based on this feedback, necessary adjustments are made before finalizing the release. This phase sets the stage for subsequent versions that will incorporate full server functionality with Phoenix integration and additional transport support.","ref":"rfc.html#5-5-phase-5-beta-release-and-feedback-week-10"},{"type":"extras","title":"6. Conclusion - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"This RFC has outlined the complete technical design for an Elixir MCP library that provides both client and server capabilities. The public API is designed to be high‑level for the client—abstracting connection and message handling—and fully compliant with Phoenix for the server side. The document details the architecture, internal flows, and the phased roadmap for version 0.1.0, focusing initially on establishing a robust client interface. The modular, extensible design ensures that the library can evolve to support additional features such as dynamic tool registration, middleware enhancements, and alternative transport mechanisms.","ref":"rfc.html#6-conclusion"},{"type":"extras","title":"References - RFC: Elixir MCP Library – Unified Client and Server with Phoenix Integration","doc":"1.\tIntroducing the Model Context Protocol – Anthropic\n2.\tMCP Quickstart – Glama\n3.\tModel Context Protocol – Linkup","ref":"rfc.html#references"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}